#include <gtk/gtk.h>
#include <stdio.h>
#include <glib.h>

#ifdef GNOME
  #include <gnome.h>
#endif

#include "gui.h"
#include "events.h"
#include "main.h"
#include "menu.h"
#include "chatbymsg.h"
#include "ejpair.h"

void chatbymsg_send(GtkWidget *w, chatbymsg_struct *s)
{
char *txt=NULL;
char *buf=NULL;
float endpos;
gboolean scroll=FALSE;

	txt=gtk_entry_get_text(GTK_ENTRY(s->entry));
	if (strcmp(txt,"")==0) return;

	gtk_entry_set_text(GTK_ENTRY(s->entry), "");

	endpos=GTK_TEXT(s->text)->vadj->upper - GTK_TEXT(s->text)->vadj->lower - GTK_TEXT(s->text)->vadj->page_size;
	if (endpos==GTK_TEXT(s->text)->vadj->value) scroll=TRUE;
	gtk_text_freeze (GTK_TEXT(s->text));
	gtk_text_set_point(GTK_TEXT(s->text), gtk_text_get_length(GTK_TEXT(s->text)));

	gtk_text_insert(GTK_TEXT(s->text), NULL, NULL, NULL, "\n<", -1);
	gtk_text_insert(GTK_TEXT(s->text), NULL, NULL, NULL, ouruser->str, -1);
	gtk_text_insert(GTK_TEXT(s->text), NULL, NULL, NULL, "> ", -1);
	gtk_text_insert(GTK_TEXT(s->text), NULL, NULL, NULL, txt, -1);
	gtk_text_thaw (GTK_TEXT(s->text));
	if (scroll) gtk_adjustment_set_value(GTK_TEXT(s->text)->vadj, GTK_TEXT(s->text)->vadj->upper - GTK_TEXT(s->text)->vadj->lower - GTK_TEXT(s->text)->vadj->page_size);

  buf=strgrow(buf,"<message><to>",1,0);
  buf=strgrow(buf,strescape(s->u->uname->str),1,1);
  buf=strgrow(buf,"</to>",1,0);

	buf=strgrow(buf,"<thread>",1,0);
	buf=strgrow(buf,strescape(s->thread->str),1,1);
	buf=strgrow(buf,"</thread>",1,0);

  buf=strgrow(buf,"<say>",1,0);
	buf=strgrow(buf,strescape(txt),1,1);
  buf=strgrow(buf,"</say>",1,0);

  buf=strgrow(buf,"</message>",1,0);

  send_data(buf);
  g_free(buf);  
}


void chatbymsg_newmsg(chatbymsg_struct *s, msg_struct *m)
{
char *x=NULL, *y=NULL, *x2=NULL;
float endpos;
gboolean scroll=FALSE;
GdkFont *fnt;
	
	if (m->msg==NULL)
		{
		free_msgstruct(m);
		return;
		}

	y=strgrow(y,"\n<",1,0);
	y=strgrow(y,m->fromid,1,0);
	if (m->fromnick!=NULL)
		{
		y=strgrow(y,"/",1,0);
		y=strgrow(y,m->fromnick,1,0);
		}
	y=strgrow(y,"> ",1,0);

	x2=strrepl(m->msg, "\n\n", "\n");
	x=strrepl(x2, "\n", y);
	g_free(x2);

	endpos=GTK_TEXT(s->text)->vadj->upper - GTK_TEXT(s->text)->vadj->lower - GTK_TEXT(s->text)->vadj->page_size;
	if (endpos==GTK_TEXT(s->text)->vadj->value) scroll=TRUE;

//  fnt = gdk_font_load ("-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*");
  fnt = gdk_font_load ("-adobe-helvetica-bold-r-normal--*-120-*-*-*-*-*-*");

	gtk_text_freeze (GTK_TEXT(s->text));
	gtk_text_set_point(GTK_TEXT(s->text), gtk_text_get_length(GTK_TEXT(s->text)));
	gtk_text_insert(GTK_TEXT(s->text), fnt, NULL, NULL, y, -1);
	gtk_text_insert(GTK_TEXT(s->text), fnt, NULL, NULL, x, -1);
	gtk_text_thaw (GTK_TEXT(s->text));
	if (scroll) gtk_adjustment_set_value(GTK_TEXT(s->text)->vadj, GTK_TEXT(s->text)->vadj->upper - GTK_TEXT(s->text)->vadj->lower - GTK_TEXT(s->text)->vadj->page_size);

  gdk_font_unref(fnt);

	g_free(x);
	g_free(y);
	free_msgstruct(m);
}

void free_chatbymsg(chatbymsg_struct *s)
{
s->u->chatbymsg=NULL;
g_string_free(s->thread,TRUE);
gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/ChatByMessage"),TRUE);
}

chatbymsg_struct *create_chatbymsg(userstruct *u)
{
  GtkWidget *vbox1;
/*
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *entry1;
*/
  GtkWidget *hbox3;
  GtkWidget *hbox4;
  GtkWidget *vscrollbar1;
  GtkWidget *but;
	chatbymsg_struct *s;
	char x[4096];
	
	if (u->chatbymsg!=NULL) return(NULL);

	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/ChatByMessage"),FALSE);
	
	s=g_malloc(sizeof(chatbymsg_struct));
	s->u=u;	
	s->thread=g_string_new("chatbymessage");
	u->chatbymsg=(gpointer)s;

  s->win = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_container_border_width (GTK_CONTAINER (s->win), 3);
  sprintf(x,"Chat by message (%s)",u->uname->str);
  gtk_window_set_title (GTK_WINDOW (s->win), x);
  gtk_window_set_policy (GTK_WINDOW (s->win), TRUE, TRUE, FALSE);
  gtk_signal_connect_object(GTK_OBJECT(s->win),"destroy",GTK_SIGNAL_FUNC(free_chatbymsg),(gpointer)s);
  gtk_signal_connect(GTK_OBJECT(s->win),"delete_event",GTK_SIGNAL_FUNC(chatbymsg_delete_event),NULL);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (s->win), vbox1);

/*
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  label1 = gtk_label_new ("Thread:");
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label1), 1, 0.5);

  entry1 = gtk_entry_new ();
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (hbox1), entry1, TRUE, TRUE, 0);
  gtk_entry_set_editable (GTK_ENTRY (entry1), FALSE);
  gtk_entry_set_text (GTK_ENTRY (entry1), s->thread->str);
*/

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  s->text = gtk_text_new (NULL, NULL);
  gtk_widget_show (s->text);
  gtk_box_pack_start (GTK_BOX (hbox3), s->text, TRUE, TRUE, 0);

  vscrollbar1 = gtk_vscrollbar_new (GTK_TEXT(s->text)->vadj);
  gtk_widget_show (vscrollbar1);
  gtk_box_pack_start (GTK_BOX (hbox3), vscrollbar1, FALSE, TRUE, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox4, FALSE, TRUE, 0);

  s->entry = gtk_entry_new ();
  gtk_widget_show (s->entry);
  gtk_box_pack_start (GTK_BOX (hbox4), s->entry, TRUE, TRUE, 0);

  but = gtk_button_new_with_label ("Close");
  gtk_widget_show (but);
  gtk_box_pack_end(GTK_BOX (hbox4), but, FALSE, TRUE, 0);
  gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),(gpointer)(s->win));

  gtk_signal_connect(GTK_OBJECT(s->entry), "activate",
		      GTK_SIGNAL_FUNC(chatbymsg_send), (gpointer)s);
	gtk_widget_show(s->win);

	return(s);
}

gint chatbymsg_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
gtk_widget_destroy(widget);
return(TRUE);
}
