#include <gtk/gtk.h>
#include <stdio.h>
#include <time.h>
#include <glib.h>

#ifdef GNOME
  #include <gnome.h>
#endif

#include "gui.h"
#include "miscwin.h"
#include "menu.h"
#include "xpm.h"
#include "events.h"
#include "mpair.h"
#include "readwin.h"
#include "sendwin.h"
#include "prefswin.h"


void loginwin_Ok()
{
connect_login(gtk_entry_get_text(GTK_ENTRY(loginwin.ent_uid)),gtk_entry_get_text(GTK_ENTRY(loginwin.ent_pass)),gtk_entry_get_text(GTK_ENTRY(loginwin.ent_nick)));
if (sock>-1) gtk_widget_destroy(loginwin.win);
}

void Status_Change(gpointer data)
{
statuswin.data=(int)data;
create_statuswin();
}

void statuswin_Ok()
{
char *x;
x=gtk_entry_get_text(GTK_ENTRY(statuswin.entry));
ourtext=g_string_assign(ourtext,x);

ourstatus_num=statuswin.data;

if (statuswin.data==0) ourstatus=S_ONLINE;
				  else ourstatus=S_OFFLINE;

send_status(ourstatus, ourtext->str, ourpri, I_NORMAL);
gtk_widget_destroy(statuswin.win);
}

void statuswin_Destroy()
{
gtk_option_menu_set_history(GTK_OPTION_MENU(statusmenu),ourstatus_num);
}


void extstatuswin_Ok()
{
char *x;

x=gtk_entry_get_text(GTK_ENTRY(extstatuswin.ent_desc));
ourtext=g_string_assign(ourtext,x);

ourstatus_num=extstatuswin.status;

if (extstatuswin.status==0) ourstatus=S_ONLINE;
					   else ourstatus=S_OFFLINE;
gtk_option_menu_set_history(GTK_OPTION_MENU(statusmenu),ourstatus_num);

ouricon_num=extstatuswin.icon;
if (extstatuswin.icon==1) ouricon=I_AWAY;
					 else ouricon=I_NORMAL;

ourpri=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(extstatuswin.spin_pri));

send_status(ourstatus, ourtext->str, ourpri, ouricon);
gtk_widget_destroy(extstatuswin.win);
}

void ExtStatus_Change(gpointer data)
{
extstatuswin.status=(int)data;
}

void ExtStatus_ChangeIcon(gpointer data)
{
extstatuswin.icon=(int)data;
}


void rostwin_FuncChange(gpointer data)
{
gboolean b;
rostwin.func=(gint)data;

b=FALSE;
if ((rostwin.func==0) || (rostwin.func==2) || (rostwin.func==3) || (rostwin.func==5)) b=TRUE;
gtk_widget_set_sensitive(rostwin.entry,b);
}


void rostwin_ok(GtkWidget *w, gpointer data)
{
groupstruct *r=NULL;
char *text;

  if (groups>0) r=gtk_object_get_user_data(GTK_OBJECT(GTK_NOTEBOOK(notebook)->cur_page->child));

  if ((rostwin.func==0) && (groups>0)) // add user
	{
	text=gtk_entry_get_text(GTK_ENTRY(rostwin.entry));
	if (strcmp(text,"")!=0)
	  {
	  add_user(rostwin.g, text, S_OFFLINE);
	  send_roster_add(rostwin.g->groupname->str,text);
	  }
	}

  if ((rostwin.func==2) && (groups>0)) // edit user
	{
	text=gtk_entry_get_text(GTK_ENTRY(rostwin.entry));
	if (strcmp(text,"")!=0)
	  {
  	  send_roster_del(rostwin.u->group->groupname->str,rostwin.u->uname->str);
	  remove_all_transports(rostwin.u);
	  edit_user(rostwin.u, text, S_OFFLINE);
	  send_roster_add(rostwin.u->group->groupname->str,text);
	  }
	}

  if ((rostwin.func==1) && (groups>0)) // remove user
	{
    send_roster_del(rostwin.u->group->groupname->str,rostwin.u->uname->str);
	remove_user(rostwin.u);
	}

  if (rostwin.func==3) // add group
	{
	text=gtk_entry_get_text(GTK_ENTRY(rostwin.entry));
	if (strcmp(text,"")!=0)
	  {
	  add_group(text);
	  send_roster_add(text,NULL);
	  }
	}

  if (rostwin.func==5) // edit group
	{
	text=gtk_entry_get_text(GTK_ENTRY(rostwin.entry));
	if (strcmp(text,"")!=0)
	  {
	  GList *l;
      send_roster_del(rostwin.g->groupname->str,NULL);
	  edit_group(rostwin.g,text);
	  send_roster_add(text,NULL);
	  l=rostwin.g->u;
	  while(l!=NULL)
		{
		send_roster_add(text,((userstruct *)(l->data))->uname->str);
		l=l->next;
		}
	  }
	}

  if ((rostwin.func==4) && (groups>0)) // remove group
    {
    send_roster_del(rostwin.g->groupname->str,NULL);
	remove_group(rostwin.g);
	}

gtk_widget_destroy(rostwin.win);
if ((rostwin.g!=NULL) && (rostwin.func!=4) && (rostwin.func!=5)) gtk_clist_unselect_all(GTK_CLIST((rostwin.g)->clist));
}

gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
if (widget==rostwin.win) return(FALSE);
if (widget==statuswin.win) return(FALSE);
save_state();
return(FALSE);
}

void destroy (GtkWidget *widget, gpointer data)
{
if (widget==rostwin.win) return;
gtk_main_quit();
}

GtkWidget* new_pixmap (gchar *filename[], GdkWindow *window, GdkColor  *background)
{
  GtkWidget *wpixmap;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  pixmap = gdk_pixmap_create_from_xpm_d (window, &mask, background,filename);
  wpixmap = gtk_pixmap_new (pixmap, mask);
  gdk_pixmap_unref (pixmap);
  return wpixmap;
}


void clist_click_column (GtkCList *aclist, gint column, gpointer data)
{
  if (column == aclist->sort_column)
    {
      if (aclist->sort_type == GTK_SORT_ASCENDING)
	aclist->sort_type = GTK_SORT_DESCENDING;
      else
	aclist->sort_type = GTK_SORT_ASCENDING;
    }
  else
    gtk_clist_set_sort_column (aclist, column);

  gtk_clist_sort(aclist);
}



void ctree_select_unselect(GtkCTree *ctree, GtkCTreeNode *row, gint column, gpointer data)
{
groupstruct *r=NULL;
StrucType t=EMPTY;
gpointer *p;

  if (groups>0) r=gtk_object_get_user_data(GTK_OBJECT(GTK_NOTEBOOK(notebook)->cur_page->child));
		   else return;

  p=gtk_ctree_node_get_row_data(GTK_CTREE(ctree),row);
  if (p!=NULL) t=((imstruct *)p)->TYPE;

  if (((gint)data==1) && (r->online!=row) && (r->offline!=row))
	{
	r->selecteditem=row;
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Message"),TRUE);

	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit user"),TRUE);
/*
	if (t==TRANSPORT)
	  {
	  }
*/
	}
	else
	{
	r->selecteditem=NULL;
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Message"),FALSE);

	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit user"),FALSE);
	}
}


void switch_page(GtkNotebook     *notebook, GtkNotebookPage *page, guint page_num, gpointer data)
{
groupstruct *r=NULL;

  if (groups>0) r=gtk_object_get_user_data(GTK_OBJECT(page->child));
		   else return;

  if (r->selecteditem==NULL)
	{
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit user"),FALSE);
	}
	else
	{
	gpointer *p;
	StrucType t=EMPTY;

    p=gtk_ctree_node_get_row_data(GTK_CTREE(r->clist),r->selecteditem);
	if (p!=NULL) t=((imstruct *)p)->TYPE;

	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit user"),TRUE);
/*
	if (t==TRANSPORT)
	  {
	  }
*/
	}
}


GtkWidget *create_status_content(gchar *img[],gchar *text)
{
GtkWidget *hbox;
GtkWidget *l;
GtkWidget *p;

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);

  if (img!=NULL)
	{
    p=new_pixmap(img,win->window,&win->style->bg[GTK_STATE_NORMAL]);
	gtk_widget_show(p);
    gtk_box_pack_start(GTK_BOX(hbox),p,FALSE,TRUE,0);
	}

  l = gtk_label_new (text);
  gtk_widget_show(l);
  gtk_label_set_justify (GTK_LABEL(l), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC(l), 0, 0.5);
  gtk_box_pack_start(GTK_BOX(hbox),l,TRUE,TRUE,2);

  return(hbox);
}


void draw_transport(imstruct *im)
{
groupstruct *r;
userstruct *u;
gchar *a[1];
GdkPixmap *pixmap;
GdkBitmap *mask;
char b[1024];
char **pix;

  u=(userstruct *)(im->parent);
  r=u->group;

  sprintf(b,"%s:%d",im->user->str,im->pri);

  a[0]=b;

if (im->status_type==S_ONLINE) pix=online_xpm;
					      else pix=offline_xpm;

  pixmap = gdk_pixmap_create_from_xpm_d(win->window, &mask, &win->style->bg[GTK_STATE_NORMAL],pix);

  gtk_clist_freeze(GTK_CLIST(r->clist));
  im->node=gtk_ctree_insert_node(GTK_CTREE(r->clist),u->node,NULL,a,0,pixmap,mask,pixmap,mask,TRUE,FALSE);
  gdk_pixmap_unref(pixmap);

  gtk_ctree_node_set_row_data(GTK_CTREE(r->clist),im->node,(gpointer)im);
  gtk_clist_thaw(GTK_CLIST(r->clist));
}


imstruct *add_transport(userstruct *u, char *uid, StatusType status_type, char *status, IconType icon_type, signed int pri)
{
groupstruct *r;
imstruct *im;

  if (nick2struc(u,uid)!=NULL)
	{
	fprintf(stderr,"\nTransport already exists, ignored");
	fflush(stderr);
	return(NULL);
	}

  r=u->group;

  im=(imstruct *)g_malloc(sizeof(imstruct));

  im->TYPE=TRANSPORT;
  im->user=g_string_new(uid);
  im->status=g_string_new(status);
  im->status_type=status_type;
  im->icon_type=icon_type;
  im->pri=pri;
  im->parent=(gpointer)u;

  draw_transport(im);

  u->im=g_list_append(u->im,(gpointer)im);
  if (status_type==S_OFFLINE) u->offline_transports++;
						 else u->online_transports++;
  check_move_user_if_status(u);

  return(im);
}


void remove_transport(imstruct *im)
{
  userstruct *u;
  groupstruct *r;

  u=(userstruct *)(im->parent);
  r=u->group;
  gtk_ctree_remove_node(GTK_CTREE(r->clist),im->node);
  u->im=g_list_remove(u->im,(gpointer)im);
  if (im->status_type==S_OFFLINE) u->offline_transports--;
							 else u->online_transports--;
  g_string_free(im->user,TRUE);
  g_string_free(im->status,TRUE);

  g_free(im);

  check_move_user_if_status(u);
}


userstruct *add_user(groupstruct *r, char *username, StatusType status_type)
{
gchar *a[1];
GdkPixmap *pixmap;
GdkBitmap *mask;
GdkPixmap *pixmap2;
GdkBitmap *mask2;
userstruct *u;
char **pix, **pix2;
GtkCTreeNode *wheretoadd;

  if (uname2struc(username)!=NULL)
	{
	fprintf(stderr,"\nUser already exists, ignored");
	fflush(stderr);
	return(NULL);
	}

  u=(userstruct *)g_malloc(sizeof(userstruct));

  u->TYPE=USER;
  u->uname=g_string_new(username);
  u->im=NULL;
  u->status_type=status_type;
  u->online_transports=0;
  u->offline_transports=0;
  u->group=r;
  u->msgs=NULL;
  u->num_msgs=0;
  u->readwin=NULL;
  u->iconqueue=NULL;
	u->chatbymsg=NULL;
  
  a[0]=username;

if (status_type==S_ONLINE)
  {
  pix=online_xpm;
  pix2=online_closed_xpm;
  wheretoadd=r->online;
  }
else
  {
  pix=offline_xpm;
  pix2=offline_closed_xpm;
  wheretoadd=r->offline;
  }

  pixmap = gdk_pixmap_create_from_xpm_d(win->window, &mask, &win->style->bg[GTK_STATE_NORMAL],pix);
  pixmap2 = gdk_pixmap_create_from_xpm_d(win->window, &mask2, &win->style->bg[GTK_STATE_NORMAL],pix2);
  u->node=gtk_ctree_insert_node(GTK_CTREE(r->clist),wheretoadd,NULL,a,0,pixmap2,mask2,pixmap,mask,FALSE,TRUE);

  gtk_ctree_node_set_row_data(GTK_CTREE(r->clist),u->node,(gpointer)u);

  gdk_pixmap_unref(pixmap);
  gdk_pixmap_unref(pixmap2);

  r->u=g_list_append(r->u,(gpointer)u);
  r->users++;

  return(u);
}


void remove_user(userstruct *u)
{
groupstruct *r;
msg_struct *m;

  r=u->group;
  
  gtk_clist_freeze(GTK_CLIST(r->clist));
  while (u->im)
    {		
	remove_transport((imstruct *)(u->im->data));
    }
  g_list_free(u->im);
  g_string_free(u->uname,TRUE);
  gtk_ctree_remove_node(GTK_CTREE(r->clist),u->node);

  while(u->msgs)
	{
	m=(msg_struct *)(u->msgs->data);
	free_msgstruct(m);
	u->msgs=g_list_remove(u->msgs,(gpointer)m);
	}
/*
FIXME: free/destroy readwin and stuff
*/
  g_list_free(u->iconqueue);

  r->u=g_list_remove(r->u,(gpointer)u);
  r->users--;
  g_free(u);

  gtk_clist_thaw(GTK_CLIST(r->clist));
}

groupstruct *add_group(char *title)
{
GtkWidget *sw;
GtkWidget *cl;
GtkWidget *l;
groupstruct *r;
gchar *a[1];
GdkPixmap *pixmap;
GdkBitmap *mask;
GdkPixmap *pixmap2;
GdkBitmap *mask2;

  sw = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (sw);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  cl = gtk_ctree_new(1,0);
  gtk_widget_show (cl);

  gtk_clist_set_selection_mode (GTK_CLIST(cl),GTK_SELECTION_SINGLE);

  gtk_container_add (GTK_CONTAINER (sw), cl);
  gtk_ctree_set_reorderable(GTK_CTREE(cl), FALSE);
  gtk_ctree_set_line_style(GTK_CTREE(cl), GTK_CTREE_LINES_DOTTED);
/*  gtk_ctree_set_line_style(GTK_CTREE(cl), GTK_CTREE_LINES_TABBED); */
  gtk_ctree_set_expander_style(GTK_CTREE(cl), GTK_CTREE_EXPANDER_NONE);
  gtk_ctree_set_indent(GTK_CTREE(cl),10);

/* maybe it's the one who restores the default size after window resize
  gtk_clist_set_column_width (GTK_CLIST (cl), 0, 92);
  gtk_clist_set_column_auto_resize (GTK_CLIST(cl), 0, FALSE);
  gtk_clist_set_column_resizeable (GTK_CLIST(cl), 0, TRUE);
*/

  gtk_clist_column_titles_hide (GTK_CLIST (cl));

  gtk_signal_connect(GTK_OBJECT(cl),"tree_select_row",GTK_SIGNAL_FUNC(ctree_select_unselect),(gpointer)1);
  gtk_signal_connect(GTK_OBJECT(cl),"tree_unselect_row",GTK_SIGNAL_FUNC(ctree_select_unselect),(gpointer)0);
		
  gtk_signal_connect(GTK_OBJECT(cl),"button_press_event",GTK_SIGNAL_FUNC(popup_menu),NULL);
/*
  gtk_signal_connect(GTK_OBJECT(cl),"click_column",(GtkSignalFunc)clist_click_column,NULL);

  l = gtk_label_new ("User");
  gtk_widget_show (l);
  gtk_label_set_justify(GTK_LABEL(l), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(l), 0, 0.5);
  gtk_clist_set_column_widget(GTK_CLIST(cl), 0, l);

  l = gtk_label_new ("Pri");
  gtk_widget_show (l);
  gtk_label_set_justify(GTK_LABEL(l), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment(GTK_MISC(l), 1, 0.5);
  gtk_clist_set_column_widget(GTK_CLIST(cl), 1, l);
*/

  l = gtk_label_new (title);
  gtk_widget_show (l);
  gtk_label_set_justify(GTK_LABEL(l), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(l), 0, 0.5);

  gtk_notebook_append_page(GTK_NOTEBOOK(notebook),sw,l);


  r=(groupstruct *)g_malloc(sizeof(groupstruct));
  r->label=l;
  r->clist=cl;
  gtk_object_set_user_data(GTK_OBJECT(sw),(gpointer)r);
  gtk_object_set_user_data(GTK_OBJECT(cl),(gpointer)r);

  a[0]="Online";
  pixmap2 = gdk_pixmap_create_from_xpm_d(win->window, &mask2, &win->style->bg[GTK_STATE_NORMAL],online_closed_xpm);
  pixmap = gdk_pixmap_create_from_xpm_d(win->window, &mask, &win->style->bg[GTK_STATE_NORMAL],online_xpm);
  r->online=gtk_ctree_insert_node(GTK_CTREE(r->clist),NULL,NULL,a,0,pixmap2,mask2,pixmap,mask,FALSE,TRUE);
  gdk_pixmap_unref (pixmap);
  gdk_pixmap_unref (pixmap2);

  a[0]="Offline";
  pixmap2 = gdk_pixmap_create_from_xpm_d(win->window, &mask2, &win->style->bg[GTK_STATE_NORMAL],offline_closed_xpm);
  pixmap = gdk_pixmap_create_from_xpm_d(win->window, &mask, &win->style->bg[GTK_STATE_NORMAL],offline_xpm);
  r->offline=gtk_ctree_insert_node(GTK_CTREE(r->clist),NULL,NULL,a,0,pixmap2,mask2,pixmap,mask,FALSE,TRUE);
  gdk_pixmap_unref (pixmap);
  gdk_pixmap_unref (pixmap2);

  r->users=0;
  r->groupname=g_string_new(title);
  r->TYPE=GROUP;
  r->selecteditem=NULL;

  r->u=NULL;
  r->num=groups;

  grouplist=g_list_append(grouplist,(gpointer)r);
  grouphash=mpair_add(grouphash,r->groupname->str,(void *)r);

  groups++;
  
  if (groups==1)
	{
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Add user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Add user"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit group"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit group"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove group"),TRUE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove group"),TRUE);
	}

  return(r);
}

void popup_menu(GtkWidget *widget,GdkEventButton *event,gpointer data)
{
  gint x, y;
  
  if (event->button==3)
	{
	gdk_window_get_pointer(NULL, &x, &y, NULL);
	gtk_item_factory_popup(it_popup,x,y,event->button,event->time);
	}
}


void remove_group(groupstruct *r)
{
  gtk_clist_freeze(GTK_CLIST(r->clist));

  while (r->u)
    {		
	remove_user((userstruct *)(r->u->data));
    }
  g_list_free(r->u);
  g_string_free(r->groupname,TRUE);

  gtk_widget_destroy(r->clist);

  gtk_notebook_remove_page(GTK_NOTEBOOK(notebook),r->num);
  grouplist=g_list_remove(grouplist,(gpointer)r);
  grouphash=mpair_remove(grouphash, r->groupname->str, 0);
  
  {
  GList *l;
  
  l=grouplist;
  while(l!=NULL)
	{
	groupstruct *g;
	
	g=(groupstruct *)(l->data);
	if ((unsigned int)(g->num)>r->num) (unsigned int)(g->num)--;
	l=l->next;
	}
  }

  groups--;
  if (groups==0)
    {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Add user"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Add user"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit user"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit user"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove user"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove user"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit group"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit group"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove group"),FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove group"),FALSE);
    }

  g_free(r);
}


void edit_transport(imstruct *im, char *uid, StatusType status_type, char *status, IconType icon_type, signed int pri)
{
userstruct *u;
groupstruct *r;
char b[1024];
gchar *a[1];
GdkPixmap *pixmap;
GdkBitmap *mask;
GtkCTreeNode *n;

  u=(userstruct *)(im->parent);
  r=u->group;
  
  im->user=g_string_assign(im->user, uid);
  im->status=g_string_assign(im->status, status);
  if (im->status_type!=status_type)
	{
	if (status_type==S_OFFLINE)
	  {
	  u->offline_transports++;
	  u->online_transports--;
	  }
	else
	  {
	  u->online_transports++;
	  u->offline_transports--;
	  }
	}
  im->status_type=status_type;
  im->icon_type=icon_type;
  im->pri=pri;

  sprintf(b,"%s:%d",uid,pri);

  a[0]=b;

{
char **pix;
if (status_type==S_ONLINE) pix=online_xpm;
					  else pix=offline_xpm;

  pixmap = gdk_pixmap_create_from_xpm_d(win->window, &mask, &win->style->bg[GTK_STATE_NORMAL],pix);
}

  gtk_clist_freeze(GTK_CLIST(r->clist));
  n=gtk_ctree_insert_node(GTK_CTREE(r->clist),u->node,im->node,a,0,pixmap,mask,pixmap,mask,TRUE,FALSE);
  gtk_ctree_remove_node(GTK_CTREE(r->clist),im->node);
  gtk_ctree_node_set_row_data(GTK_CTREE(r->clist),n,(gpointer)im);
  gtk_clist_thaw(GTK_CLIST(r->clist));

  im->node=n;

  gdk_pixmap_unref(pixmap);

  check_move_user_if_status(u);
}

void edit_user(userstruct *u, char *username, StatusType status_type)
{
gchar *a[1];
GdkPixmap *pixmap;
GdkBitmap *mask;
GdkPixmap *pixmap2;
GdkBitmap *mask2;
GtkCTreeNode *n;
groupstruct *r;
GList *l;
GtkCTreeNode *wheretoadd, *sibling;
gboolean is_leaf, expanded;


  r=u->group;  

  u->uname=g_string_assign(u->uname, username);
  
  a[0]=username;

  if (status_type==S_ONLINE)
  	{
	wheretoadd=r->online;
	}
  else
	{
	wheretoadd=r->offline;
	}

  if (status_type==u->status_type) sibling=u->node;
  							  else sibling=NULL;

  u->status_type=status_type;

  gtk_clist_freeze(GTK_CLIST(r->clist));

  gtk_ctree_get_node_info(GTK_CTREE(r->clist),u->node,NULL,NULL,&pixmap,&mask,&pixmap2,&mask2,&is_leaf,&expanded);

  pixmap=gdk_pixmap_ref(pixmap);
  pixmap2=gdk_pixmap_ref(pixmap2);
/*
  mask=gdk_bitmap_ref(mask);
  mask2=gdk_bitmap_ref(mask2);
*/

  n=gtk_ctree_insert_node(GTK_CTREE(r->clist),wheretoadd,sibling,a,0,pixmap2,mask2,pixmap,mask,is_leaf,expanded);

  gtk_ctree_remove_node(GTK_CTREE(r->clist),u->node);
  gtk_ctree_node_set_row_data(GTK_CTREE(r->clist),n,(gpointer)u);
  gtk_clist_thaw(GTK_CLIST(r->clist));

  u->node=n;

  gdk_pixmap_unref(pixmap);
  gdk_pixmap_unref(pixmap2);
/*  
  gdk_bitmap_unref(mask);
  gdk_bitmap_unref(mask2);
*/

  update_icon(u);

  l=u->im;
  while(l!=NULL)
	{
	draw_transport((imstruct *)(l->data));
	l=l->next;
	}  

  gtk_ctree_expand(GTK_CTREE(r->clist),r->online);
/*
  gtk_ctree_expand(GTK_CTREE(r->clist),r->offline);
  gtk_ctree_expand(GTK_CTREE(r->clist),u->node);
*/
}


void edit_group(groupstruct *r, char *title)
{
r->groupname=g_string_assign(r->groupname, title);
gtk_label_set_text(GTK_LABEL(r->label),title);
}


void add_debug()
{
gchar *s;
s=g_strdup(gtk_editable_get_chars(&(GTK_TEXT(debug.text)->editable),0,gtk_text_get_length(GTK_TEXT(debug.text))));
events_got_stream(s);
g_free(s);
gtk_editable_delete_text(&(GTK_TEXT(debug.text)->editable),0,gtk_text_get_length(GTK_TEXT(debug.text)));
}

void check_move_user_if_status(userstruct *u)
{
char *s=NULL;

if ((u->online_transports==0) && (u->status_type==S_ONLINE))
  {
  s=g_strdup(u->uname->str);
  edit_user(u, s, S_OFFLINE);
  }
else if ((u->online_transports>0) && (u->status_type==S_OFFLINE))
  {
  s=g_strdup(u->uname->str);
  edit_user(u, s, S_ONLINE);
  }

g_free(s);
}


userstruct *uname2struc(char *uid)
{
GList *l, *ul;
groupstruct *r;
userstruct *u;

if (uid==NULL) return(NULL);

l=grouplist;
while (l!=NULL)
  {
  r=(groupstruct *)(l->data);
  ul=r->u;
  while(ul!=NULL)
	{
	u=(userstruct *)(ul->data);
	if (strcasecmp(uid,u->uname->str)==0) return(u);
	ul=ul->next;
	}
  l=l->next;
  }
return(NULL);
}


imstruct *nick2struc(userstruct *u, char *nick)
{
GList *l;
imstruct *im;

if (nick==NULL) return(NULL);

l=u->im;
while (l!=NULL)
  {
  im=(imstruct *)(l->data);
  if (strcasecmp(nick,im->user->str)==0) return(im);
  l=l->next;
  }
return(NULL);
}


groupstruct *groupname2struc(char *name)
{
GList *l;
groupstruct *r;

if (name==NULL) return(NULL);

l=grouplist;
while (l!=NULL)
  {
  r=(groupstruct *)(l->data);
	if (strcasecmp(name,r->groupname->str)==0) return(r);
	l=l->next;
	}
return(NULL);
}


gint hide_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
gtk_widget_hide(widget);
return(TRUE);
}


void ChangeNodePixmaps(GtkWidget *ctree, GtkCTreeNode *node, char **pix_opened, char **pix_closed)
{
GdkPixmap *pixmap;
GdkBitmap *mask;
GdkPixmap *pixmap2;
GdkBitmap *mask2;
gchar *text=NULL;
gchar *text2=NULL;
guint8 spacing;
gboolean is_leaf;
gboolean expanded;
GdkPixmap *a1,*a2;
GdkBitmap *b1,*b2;

  gtk_clist_freeze(GTK_CLIST(ctree));

/* FIXME: creates pixmaps using the main window's GdkWindow (differs palette on 8bpp?) */
  pixmap = gdk_pixmap_create_from_xpm_d(win->window, &mask, &win->style->bg[GTK_STATE_NORMAL],pix_opened);
  pixmap2 = gdk_pixmap_create_from_xpm_d(win->window, &mask2, &win->style->bg[GTK_STATE_NORMAL],pix_closed);

  gtk_ctree_get_node_info(GTK_CTREE(ctree),node,&text,&spacing,&a1,&b1,&a2,&b2,&is_leaf,&expanded);
  text2=g_strdup(text);
  gtk_ctree_set_node_info(GTK_CTREE(ctree),node,text2,spacing,pixmap2,mask2,pixmap,mask,is_leaf,expanded);
  g_free(text2);
  
  gdk_pixmap_unref(pixmap);
  gdk_pixmap_unref(pixmap2);

  gtk_clist_thaw(GTK_CLIST(ctree));
}


void remove_all_transports(userstruct *u)
{
  while (u->im)
    {		
	remove_transport((imstruct *)(u->im->data));
    }
  g_list_free(u->im);
  u->im=NULL;
}


void free_msgstruct(msg_struct *m)
{
if (m!=NULL)
  {
  g_free(m->fromid);
  g_free(m->fromnick);
  g_free(m->subj);
  g_free(m->thread);
  g_free(m->date);
  g_free(m->pri);
  g_free(m->msg);
  g_free(m);
  }
}

void add_icon_to_queue(userstruct *u, IconQueueType typ)
{
if (g_list_find(u->iconqueue, (gpointer)typ)==NULL)
  {
  u->iconqueue=g_list_append(u->iconqueue, (gpointer)typ);
  update_icon(u);
  }
}

void remove_icon_from_queue(userstruct *u, IconQueueType typ)
{
if (g_list_find(u->iconqueue, (gpointer)typ)!=NULL)
  {
  u->iconqueue=g_list_remove(u->iconqueue, (gpointer)typ);
  update_icon(u);
  }
}

void update_icon(userstruct *u)
{
char **open=NULL, **closed=NULL;
GList *l;
IconQueueType iq;

l=g_list_last(u->iconqueue);
if (l!=NULL)
  {
  iq=(IconQueueType)l->data;
  
  if (iq==IQ_MESSAGE)
	{
	open=message_xpm;
	closed=message_closed_xpm;
	gdk_window_set_icon_name(win->window,"cabbar - new message");
	if (gettoggle("uniconifyevent"))
		{
		gdk_window_show(win->window);
		gdk_window_raise(win->window);
		}
	}
  else
	{
	puts("unknown IconQueueType");
	}
  }
else
  {
  gdk_window_set_icon_name(win->window,"cabbar");
  if (u->status_type==S_ONLINE)
	{
	open=online_xpm;
	closed=online_closed_xpm;
	}
  else
	{
	open=offline_xpm;
	closed=offline_closed_xpm;
	}
  }
  ChangeNodePixmaps(u->group->clist, u->node, open, closed);
}
