#include "common-cab.h"
#include "common.h"
#include <stdio.h>
#include <glib.h>

#include "gui.h"
#include "events.h"
#include "menu.h"
#include "rcvwin.h"
#include "miscwin.h"
#include "configio.h"
#include "prefswin.h"
#include "ejpair.h"

#ifdef GNOME
gint die (GnomeClient *client, gpointer client_data)
{
  gtk_exit(0);
  return(FALSE);
}
#endif

gint save_state ()
{
  gint x=-1, y=-1, w=-1, h=-1;
	char s[16];

  gdk_window_get_position(win->window, &x, &y);
  gdk_window_get_size(win->window, &w, &h);

/*
  gnome_config_push_prefix ("/cabbar/");
  
  gnome_config_set_int ("Geometry/x", x);
  gnome_config_set_int ("Geometry/y", y);
  gnome_config_set_int ("Geometry/w", w);
  gnome_config_set_int ("Geometry/h", h);

  gnome_config_pop_prefix ();
  gnome_config_sync();
*/
	sprintf(s,"%d",h);
	cfg=ejpair_replace(cfg,"height",g_strdup(s));
	sprintf(s,"%d",w);
	cfg=ejpair_replace(cfg,"width",g_strdup(s));
	sprintf(s,"%d",y);
	cfg=ejpair_replace(cfg,"ypos",g_strdup(s));
	sprintf(s,"%d",x);
	cfg=ejpair_replace(cfg,"xpos",g_strdup(s));
	
  return TRUE;
}


int main (int argc, char *argv[]) {
int x=-1,y=-1,w=-1,h=-1;

#ifdef GNOME
GnomeClient *client;

  gnome_init ("cabbar", VERSION, argc, argv);

  client=gnome_master_client();
  
  gtk_signal_connect (GTK_OBJECT (client), "save_yourself", GTK_SIGNAL_FUNC (save_state), NULL);
  gtk_signal_connect (GTK_OBJECT (client), "die", GTK_SIGNAL_FUNC (die), NULL);
#else
  gtk_set_locale();
  gtk_init(&argc, &argv);
#endif

	cfg=read_config();

	{
	char *s;
	
	s=ejpair_getval(cfg, "xpos");
	if (s!=NULL) x=atoi(s);
	s=ejpair_getval(cfg, "ypos");
	if (s!=NULL) y=atoi(s);
	s=ejpair_getval(cfg, "width");
	if (s!=NULL) w=atoi(s);
	s=ejpair_getval(cfg, "height");
	if (s!=NULL) h=atoi(s);
	}

  sock=-1;
  tag=-1;

  groups=0;
  grouplist=NULL;
  grouphash=NULL;
  ourstatus=S_OFFLINE;
  ourstatus_num=1;
  ourpri=1;
  ourtext=g_string_new("im offline");
  ouricon=I_NORMAL;
  ouricon_num=0;

	ouruser=g_string_new("");
	ournick=g_string_new("");
	ourserver=g_string_new("");
  
  server_ver=NULL;
  server_prot=NULL;
  gotjabbertag=FALSE;

  events_init();

  create_debugwin();  
  win=create_win();
  create_rcvwin();

  gtk_option_menu_set_history(GTK_OPTION_MENU(statusmenu),ourstatus_num);
  gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/User/Login"),TRUE);
  gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/User/Logout"),FALSE);

/*  gtk_widget_show_now(win);*/
  gtk_widget_show(win);

  if ((w!=-1) && (h!=-1)) gdk_window_resize(win->window,w,h);
  if ((x!=-1) && (y!=-1)) gdk_window_move(win->window,x,y);
	
	if (gettoggle("autologin"))
		{
		char *user, *pass, *nick;
		
		user=ejpair_getval(cfg,"user");
		pass=ejpair_getval(cfg,"pass");
		nick=ejpair_getval(cfg,"nick");

		if ((user==NULL) || (pass==NULL) || (nick==NULL))	create_loginwin();
																								 else connect_login(user,pass,nick);
		}

  gtk_main();
	logout(FALSE, FALSE);
/*  events_free(); logout() takes care of this for us */
	if (write_config(cfg)!=0)
		{
		fprintf(stderr,"\nError writing config file ~/.cabbar/config\n");
		}
	free_jpair(cfg);

	g_string_free(ouruser, 1);
	g_string_free(ournick, 1);
	g_string_free(ourserver, 1);

	puts("\n");
  return(0);
}
