#ifndef _MAIN_H_
#define _MAIN_H_

#include "common-cab.h"
#include "common.h"
#include "mpair.h"


typedef enum
  {
  IQ_MESSAGE
  } IconQueueType;

/* structure to buffer received messages for each user*/
typedef struct msg_struct
  {
  char *fromid;
  char *fromnick;
  char *subj;
  char *thread;
  char *date;
  char *pri;
  char *msg;
  } msg_struct;

typedef struct debugwin_struct
  {
  GtkWidget *win;
  GtkWidget *text;
  GtkWidget *scroll;
  GtkWidget *button;
  } debugwin_struct;

typedef struct loginwin_struct
  {
  GtkWidget *win;
  GtkWidget *ent_uid;
  GtkWidget *ent_pass;
  GtkWidget *ent_nick;
  GtkWidget *ok;
  GtkWidget *cancel;
  } loginwin_struct;

typedef struct statuswin_struct
  {
  GtkWidget *win;
  GtkWidget *entry;
  GtkWidget *label;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  int data;
  } statuswin_struct;

typedef struct extstatuswin_struct
  {
  GtkWidget *win;
  GtkWidget *ent_desc;
  GtkWidget *spin_pri;
  GtkWidget *option_status;
  GtkWidget *option_icon;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  int status;
  int icon;
  } extstatuswin_struct;

typedef struct sendwin_struct
  {
  GtkWidget *win;
  GtkWidget *vbox;
  GtkWidget *ent_to;
  GtkWidget *ent_nick;
  GtkWidget *ent_thread;
  GtkWidget *spin_pri;
  GtkWidget *ent_subj;
  GtkWidget *text;
  GtkWidget *but_send;
  GtkWidget *but_close;
  } sendwin_struct;

typedef struct rcvwin_struct
  {
  GtkWidget *win;
  GtkWidget *vpaned;
  GtkWidget *clist;
  GtkWidget *scrolled;
  GtkWidget *scrollbar;
  GtkWidget *text;
  GtkWidget *vbox;
  GtkWidget *but_reply;
  GtkWidget *but_forward;
  GtkWidget *but_remove;
  GtkWidget *but_close;
  GtkWidget *but_prev;
  GtkWidget *but_next;
  } rcvwin_struct;

typedef enum
{
  GROUP,
  USER,
  TRANSPORT,
  EMPTY
} StrucType;

typedef enum
{
  S_ONLINE,
  S_OFFLINE
} StatusType;

typedef enum
{
  I_NORMAL,
  I_AWAY
} IconType;

typedef struct imstruct
  {
  StrucType TYPE;
  GString *user;
  GString *status;
  StatusType status_type;
  IconType icon_type;
  signed int pri;
  GtkCTreeNode *node;
  gpointer *parent;
  } imstruct;

typedef struct groupstruct
  {
  StrucType TYPE;
  GtkWidget *clist; /* ctree */
  GtkWidget *label; /* label in notebook tab */
  GtkCTreeNode *online;
  GtkCTreeNode *offline;
  GtkCTreeNode *selecteditem;
  GString *groupname;
  unsigned int num; /* number of the notebook tab */
  unsigned int users; /* number of users */
  GList *u; /* users */
  } groupstruct;

typedef struct userstruct
  {
  StrucType TYPE;
  GString *uname;
  GtkCTreeNode *node;
  GList *im; /* transports */
  StatusType status_type; /* which branch we're under */
  unsigned int online_transports; /* number of online transports */
  unsigned int offline_transports; /* number of offline transports */
  groupstruct *group;
  GList *msgs; /* buffered messages (msg_struct) */
  unsigned int num_msgs; /* # of buffered msgs */
  GList *iconqueue; /* queued icons (IconQueueType) */
  gpointer *readwin;
	gpointer *chatbymsg;
  } userstruct;

typedef struct chatbymsg_struct
	{
	userstruct *u;
	GString *thread;
	GtkWidget *win;
	GtkWidget *entry;
	GtkWidget *text;
	} chatbymsg_struct;

typedef struct readwin_struct
  {
  GtkWidget *win;
  GtkWidget *text;
  GtkWidget *but_close;
  GtkWidget *but_next;
  GtkWidget *but_reply;
  GtkWidget *but_forward;
  userstruct *u;
  unsigned int max;
  } readwin_struct;

typedef struct rostfuncswin_struct
  {
  int func;
  int def;
  GtkWidget *win;
  GtkWidget *entry;
  GtkWidget *ok;
  GtkWidget *cancel;
  GtkWidget *optmenu;
  GtkWidget *optmenu_menu;
  GtkWidget *optmenu_item[6];
  userstruct *u;
  imstruct *im;
  groupstruct *g;
  }	rostfuncswin_struct;

typedef struct prefswin_struct
	{
	GtkWidget *win;
	GtkWidget *check1;
	GtkWidget *check2;
	GtkWidget *check3;
	GtkWidget *check4;
	GtkWidget *check5;
	GtkWidget *check6;
	GtkWidget *check7;
	GtkWidget *but_ok;
	GtkWidget *but_cancel;
	GtkWidget *but_save;
	} prefswin_struct;

GtkWidget *win;
GtkWidget *notebook;
GtkWidget *statusmenu;
rostfuncswin_struct rostwin;
statuswin_struct statuswin;
extstatuswin_struct extstatuswin;
loginwin_struct loginwin;
rcvwin_struct rcvwin;
debugwin_struct debug;
prefswin_struct prefswin;
unsigned int groups;
StatusType ourstatus; /* our status */
unsigned int ourstatus_num; /* our status in number, used for the optionmenu */
signed int ourpri; /* our priority */
GString *ourtext; /* our status text */
IconType ouricon; /* our icon */
unsigned int ouricon_num; /* our icon in number, used for the optionmenu */

GString *ouruser;
GString *ournick;
GString *ourserver;

GList *grouplist;
mpair *grouphash;
char *server_ver;
char *server_prot;
gboolean gotjabbertag;
int sock;
int tag; /* tag for gdk_input_add */
jpair *cfg;

xptpool *xpp;
mpair *wraphash;

#ifdef GNOME
  gint die (GnomeClient *client, gpointer client_data);
#endif
  gint save_state ();
int main (int argc, char *argv[]);


#endif