#include "common-cab.h"
#include "gui.h"
#include "menu.h"
#include "events.h"
#include "readwin.h"
#include "sendwin.h"
#include "miscwin.h"
#include "prefswin.h"
#include "chatbymsg.h"
#include <glib.h>

static  GtkItemFactoryEntry main_menu_items[] =
	{
  { "/_User",                   NULL,         NULL,      0, "<Branch>" },
  { "/User/_Login",      "<control>G", (GtkSignalFunc)create_loginwin,      0 },
  { "/User/_Logout",     "<control>O", (GtkSignalFunc)main_menu_cb,      0 },
  { "/User/sep0",    NULL,  NULL,      0, "<Separator>" },
  { "/User/_Received messages",  "<control>V", (GtkSignalFunc)main_menu_cb,      2 },
  { "/User/_New message",  "<control>N", (GtkSignalFunc)main_menu_cb,      3 },
  { "/User/sep1",    NULL,  NULL,      0, "<Separator>" },
  { "/User/_Toggle debug window",  NULL, (GtkSignalFunc)main_menu_cb,      4 },
  { "/User/_Preferences",      NULL, (GtkSignalFunc)main_menu_cb,      1 },
  { "/User/sep2",    NULL,  NULL,      0, "<Separator>" },
  { "/User/_Quit",        "<control>Q", (GtkSignalFunc)main_menu_quit,      0 },
  { "/_Roster",                   NULL,         NULL,      0, "<Branch>" },
  { "/Roster/A_dd user",    "<control>A",  (GtkSignalFunc)roster_cb,      0 },
  { "/Roster/_Edit user",    "<control>E",  (GtkSignalFunc)roster_cb,      2 },
  { "/Roster/Remo_ve user", "<control>D",  (GtkSignalFunc)roster_cb,      1 },
  { "/Roster/Add g_roup",   "<control>I", (GtkSignalFunc)roster_cb,      3 },
  { "/Roster/Edit gro_up",    "<control>T", (GtkSignalFunc)roster_cb,      5 },
  { "/Roster/Remove gr_oup",    "<control>R", (GtkSignalFunc)roster_cb,      4 },
  { "/Roster/sep0",    NULL,  NULL,      0, "<Separator>" },
  { "/Roster/Re_load",    "<control>L", (GtkSignalFunc)roster_cb,      6 }
	};

static  GtkItemFactoryEntry popup_items[] =
	{
  { "/_Message",    NULL,  (GtkSignalFunc)user_cb,       0},
  { "/_Read message",    NULL,  (GtkSignalFunc)user_cb,      1},
  { "/_ChatByMessage",    NULL,  (GtkSignalFunc)user_cb,      2},
  { "/separator0",    NULL,  NULL,       0, "<Separator>" },
  { "/A_dd user",    NULL,  (GtkSignalFunc)roster_cb,      0 },
  { "/_Edit user",    NULL,  (GtkSignalFunc)roster_cb,      2 },
  { "/Remo_ve user", NULL,  (GtkSignalFunc)roster_cb,      1 },
  { "/Add g_roup",   NULL, (GtkSignalFunc)roster_cb,      3 },
  { "/Edit gro_up",   NULL, (GtkSignalFunc)roster_cb,      5 },
  { "/Remove gr_oup",    NULL, (GtkSignalFunc)roster_cb,      4 },
  { "/separator1",    NULL,  NULL,      0, "<Separator>" },
  { "/Re_load",    NULL, (GtkSignalFunc)roster_cb,      6 }
	};

void disable_nonfunctional_menuitems(int a)
{
  if (a==0)
	{
/*	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/User/Prefs"),FALSE);*/


	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit group"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove group"),FALSE);

	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Add user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Edit user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(item_factory, "<main>/Roster/Remove user"),FALSE);
	}
	else
	{
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit group"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove group"),FALSE);

	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Add user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Edit user"),FALSE);
	gtk_widget_set_sensitive(gtk_item_factory_get_widget(it_popup, "<main>/Remove user"),FALSE);
	}

}

void main_menu_quit (gpointer callback_data,guint callback_action,GtkWidget *widget)
{
delete_event(win, NULL, NULL);
destroy(win, NULL);
}

void main_menu_cb (gpointer callback_data,guint callback_action,GtkWidget *widget)
{
if (callback_action==0)
  {
	logout(TRUE, TRUE);
  }
else if (callback_action==1)
  {
  create_prefswin();
  }
else if (callback_action==2)
  {
  gtk_widget_show(rcvwin.win);
  }
else if (callback_action==3)
  {
  create_sendwin(NULL, NULL, NULL, NULL, NULL, 1);
  }
else if (callback_action==4)
  {
  if (GTK_WIDGET_VISIBLE(debug.win)) gtk_widget_hide(debug.win);
								else gtk_widget_show(debug.win);
  }
}


void user_cb (gpointer callback_data,guint callback_action,GtkWidget *widget)
{
groupstruct *r=NULL;
userstruct *u=NULL;
imstruct *im=NULL;
GtkCTreeNode *g=NULL;
StrucType t=EMPTY;
gpointer *p;

  r=gtk_object_get_user_data(GTK_OBJECT(GTK_NOTEBOOK(notebook)->cur_page->child));

  if (GTK_CLIST(r->clist)->selection!=NULL)
      {
	  u=NULL;
	  g=(GtkCTreeNode *)(GTK_CLIST(r->clist)->selection->data);
	  if ((g!=r->online) && (g!=r->offline))
		{
	    p=gtk_ctree_node_get_row_data(GTK_CTREE(r->clist),g);
		t=((userstruct *)p)->TYPE;
		if (t==USER)
		  {
		  u=(userstruct *)p;
		  im=NULL;
		  }
		if (t==TRANSPORT)
		  {
		  im=(imstruct *)p;
		  u=(userstruct *)im->parent;
		  }
		}
	  }

if (callback_action==0)
  {
  char *to=NULL;
  char *nick=NULL;
  
  if (u!=NULL) to=u->uname->str;
  if (im!=NULL) nick=im->user->str;

  create_sendwin(to, nick, NULL, NULL, NULL, 1);
  }
if ((callback_action==1) && (u!=NULL))
  {
  open_readwin(u);
  }

if ((callback_action==2) && (u!=NULL))
  {
	create_chatbymsg(u);
	}
}

void roster_cb (gpointer callback_data,guint callback_action,GtkWidget *widget)
{
GtkWidget *clist;
groupstruct *r;
GtkCTreeNode *g=NULL;
StrucType t=EMPTY;
gpointer *p;
imstruct *im;
userstruct *u;

  if (callback_action==6)
	{
	send_roster_get(NULL);
	return;
	}

  create_rostwin();
  gtk_option_menu_set_history(GTK_OPTION_MENU(rostwin.optmenu),callback_action);
  rostwin_FuncChange((gpointer)callback_action);

  rostwin.im=NULL;
  rostwin.u=NULL;
  rostwin.g=NULL;
  
  if (groups==0) return;

  r=gtk_object_get_user_data(GTK_OBJECT(GTK_NOTEBOOK(notebook)->cur_page->child));
  rostwin.g=r;

  if ((callback_action==1) || (callback_action==2))
	{
    clist=r->clist;
    if (GTK_CLIST(clist)->selection!=NULL)
      {
	  u=NULL;
	  g=(GtkCTreeNode *)(GTK_CLIST(clist)->selection->data);
	  p=gtk_ctree_node_get_row_data(GTK_CTREE(clist),g);
	  t=((userstruct *)p)->TYPE;
	  if (t==TRANSPORT) // node is a transport node
		{
		im=(imstruct *)p;
		rostwin.im=im;
		u=(userstruct *)(im->parent);
		t=u->TYPE;
		p=(gpointer)u;
		}
	  if (t==USER) // node is a user node
		{
		u=(userstruct *)p;
		rostwin.u=u;
	    gtk_entry_set_text(GTK_ENTRY(rostwin.entry),u->uname->str);
		}
      }
	}

  if ((callback_action==4) || (callback_action==5))
	{
	rostwin.g=r;
	gtk_entry_set_text(GTK_ENTRY(rostwin.entry),r->groupname->str);
	}

}


GtkWidget *create_menu(GtkWidget *win)
{
  GtkAccelGroup *accel_group;
  GtkWidget *w=NULL;
  int nmenu_items;

  accel_group = gtk_accel_group_new ();

    item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>", accel_group);
	nmenu_items = sizeof (main_menu_items) / sizeof (main_menu_items[0]);
	gtk_item_factory_create_items (item_factory, nmenu_items, main_menu_items, NULL);
    gtk_accel_group_attach (accel_group, GTK_OBJECT(win));
    w=gtk_item_factory_get_widget(item_factory, "<main>");

  gtk_widget_show(w);

  disable_nonfunctional_menuitems(0);

  return(w);
}


void create_popup_menu()
{
  GtkAccelGroup *accel_group;
  int nmenu_items;

  accel_group = gtk_accel_group_new ();

  it_popup = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", accel_group);
  nmenu_items = sizeof (popup_items) / sizeof (popup_items[0]);
  gtk_item_factory_create_items (it_popup, nmenu_items, popup_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT(win));

  disable_nonfunctional_menuitems(1);
}
