/*
stolen from jpair.c in the Jabber project (www.jabber.org)
the difference is, value is void *, instead of char *
also, mpair.c implements mpair_remove, and ->prev

uses strdup to duplicate void pointers, so be careful ;) (marked with FIXME)

disq <disq@iname.com>
*/

#ifndef _MPAIR_H_
#define _MPAIR_H_

typedef struct mpair_struct
{
	char *key;
	void *val;
	int flag;
	struct mpair_struct *prev;
	struct mpair_struct *next;
} mpair;

mpair *mpair_add(mpair *p, char *key, void *val); /* !!! key and val must have been malloc'd!!! */
mpair *mpair_new(mpair *p, char *key, void *val, int flag); /* !!! key will be copied into new memory */
mpair *mpair_get(mpair *p, char *key);
void *mpair_getval(mpair *p, char *key);
void *mpair_getvalnew(mpair *p, char *key);
int mpair_getflag(mpair *p, char *key);
mpair *mpair_dup(mpair *p);
void free_mpair(mpair *p);
void mpair_print(mpair *p); /*debug function*/
mpair *mpair_append(mpair *j1, mpair *j2);
mpair *mpair_remove(mpair *p, char *key, int dofree);

#endif /* _MPAIR_H_ */
