#include <stdio.h>
#include <gtk/gtk.h>
#include "common.h"
#include "common-cab.h"
#include "prefswin.h"
#include "configio.h"
#include "ejpair.h"
#include "main.h"
#include "gui.h"


gboolean gettoggle(char *t)
{
char *s;

s=ejpair_getval(cfg,t);
if (s==NULL) return(FALSE);
if (strcasecmp(s,"yes")==0) return(TRUE);
if (strcasecmp(s,"1")==0) return(TRUE);
if (strcasecmp(s,"true")==0) return(TRUE);
return(FALSE);
}

void settoggle(char *t, gboolean b)
{
char *s;

if (b==TRUE) s=g_strdup("yes");
				else s=g_strdup("no");

cfg=ejpair_replace(cfg,t,s);
}


void prefswin_ok()
{
settoggle("dontsavepassword",(GTK_TOGGLE_BUTTON(prefswin.check1)->active));
settoggle("autologin",(GTK_TOGGLE_BUTTON(prefswin.check2)->active));
settoggle("retrylogin",(GTK_TOGGLE_BUTTON(prefswin.check3)->active));
settoggle("uniconifyconnect",(GTK_TOGGLE_BUTTON(prefswin.check4)->active));
settoggle("uniconifyevent",(GTK_TOGGLE_BUTTON(prefswin.check5)->active));
settoggle("prefsonserver",(GTK_TOGGLE_BUTTON(prefswin.check6)->active));
settoggle("noquote",(GTK_TOGGLE_BUTTON(prefswin.check7)->active));
gtk_widget_destroy(prefswin.win);
}


void prefswin_save()
{
prefswin_ok();
if (write_config(cfg)!=0)
	{
	fprintf(stderr,"\nError writing config file ~/.cabbar/config\n");
	}
}


void create_prefswin()
{
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *notebook;
	GtkWidget *label;

  prefswin.win = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (prefswin.win), "Preferences");
  gtk_window_position (GTK_WINDOW (prefswin.win), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (prefswin.win), TRUE, TRUE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (prefswin.win), vbox1);

  notebook = gtk_notebook_new ();
  gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook), FALSE);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook), TRUE);
  gtk_notebook_set_tab_hborder (GTK_NOTEBOOK (notebook), 1);
  gtk_notebook_set_tab_vborder (GTK_NOTEBOOK (notebook), 1);
  gtk_notebook_popup_enable (GTK_NOTEBOOK (notebook));
  gtk_box_pack_start (GTK_BOX (vbox1), notebook, TRUE, TRUE, 0);
  gtk_widget_show (notebook);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_border_width (GTK_CONTAINER (vbox2), 10);

  label = gtk_label_new ("Toggles");
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook),vbox2,label);

  prefswin.check1 = gtk_check_button_new_with_label ("Do not save password");
  gtk_widget_show (prefswin.check1);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check1, TRUE, TRUE, 0);

  prefswin.check2 = gtk_check_button_new_with_label ("Autologin on startup");
  gtk_widget_show (prefswin.check2);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check2, TRUE, TRUE, 0);

  prefswin.check3 = gtk_check_button_new_with_label ("Auto-Retry login");
  gtk_widget_show (prefswin.check3);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check3, TRUE, TRUE, 0);

  prefswin.check4 = gtk_check_button_new_with_label ("Uniconify on connect");
  gtk_widget_show (prefswin.check4);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check4, TRUE, TRUE, 0);

  prefswin.check5 = gtk_check_button_new_with_label ("Uniconify on event");
  gtk_widget_show (prefswin.check5);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check5, TRUE, TRUE, 0);

  prefswin.check6 = gtk_check_button_new_with_label ("Store preferences on the server-side ");
  gtk_widget_show (prefswin.check6);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check6, TRUE, TRUE, 0);

  prefswin.check7 = gtk_check_button_new_with_label ("Do not quote message when replying");
  gtk_widget_show (prefswin.check7);
  gtk_box_pack_start (GTK_BOX (vbox2), prefswin.check7, TRUE, TRUE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start(GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  prefswin.but_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_show (prefswin.but_cancel);
  gtk_box_pack_end (GTK_BOX (hbox1), prefswin.but_cancel, FALSE, TRUE, 0);
  gtk_widget_set_usize (prefswin.but_cancel, 60, 25);

  prefswin.but_ok = gtk_button_new_with_label ("Ok");
  gtk_widget_show (prefswin.but_ok);
  gtk_box_pack_end (GTK_BOX (hbox1), prefswin.but_ok, FALSE, TRUE, 0);
  gtk_widget_set_usize (prefswin.but_ok, 60, 25);

  prefswin.but_save = gtk_button_new_with_label ("Save");
  gtk_widget_show (prefswin.but_save);
  gtk_box_pack_end (GTK_BOX (hbox1), prefswin.but_save, FALSE, TRUE, 0);
  gtk_widget_set_usize (prefswin.but_save, 60, 25);

  gtk_signal_connect_object(GTK_OBJECT(prefswin.but_cancel),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),(gpointer)prefswin.win);
  gtk_signal_connect(GTK_OBJECT(prefswin.but_ok),"clicked",GTK_SIGNAL_FUNC(prefswin_ok),NULL);
  gtk_signal_connect(GTK_OBJECT(prefswin.but_save),"clicked",GTK_SIGNAL_FUNC(prefswin_save),NULL);

  if (gettoggle("dontsavepassword")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check1), TRUE);
													      else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check1), FALSE);
  if (gettoggle("autologin")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check2), TRUE);
											   else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check2), FALSE);
  if (gettoggle("retrylogin")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check3), TRUE);
											    else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check3), FALSE);
  if (gettoggle("uniconifyconnect")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check4), TRUE);
											          else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check4), FALSE);
  if (gettoggle("uniconifyevent")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check5), TRUE);
											        else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check5), FALSE);
  if (gettoggle("prefsonserver")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check6), TRUE);
 										         else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check6), FALSE);
  if (gettoggle("noquote")) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check7), TRUE);
 										   else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(prefswin.check7), FALSE);

	gtk_widget_show(prefswin.win);
}
