#include <gtk/gtk.h>
#include <stdio.h>

#ifdef GNOME
  #include <gnome.h>
#endif

#include "main.h"
#include "rcvwin.h"
#include "readwin.h"
#include "gui.h"


void create_rcvwin()
{
  GtkWidget *label;
  GtkWidget *hbox1;
  GtkWidget *hbox2;

  rcvwin.win = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (rcvwin.win), "Received Messages");
  gtk_window_set_policy (GTK_WINDOW (rcvwin.win), TRUE, TRUE, FALSE);
  gtk_container_border_width (GTK_CONTAINER (rcvwin.win), 2);
  gtk_widget_realize(rcvwin.win);
  gtk_widget_set_usize(rcvwin.win, 600, 280);

  gtk_signal_connect (GTK_OBJECT(rcvwin.win),"delete_event",GTK_SIGNAL_FUNC(hide_event),NULL);
  gtk_signal_connect_object(GTK_OBJECT(rcvwin.win),"destroy",GTK_SIGNAL_FUNC(gtk_widget_hide),(gpointer)rcvwin.win);

  rcvwin.vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (rcvwin.vbox);
  gtk_container_add (GTK_CONTAINER (rcvwin.win), rcvwin.vbox);

  rcvwin.vpaned = gtk_vpaned_new ();
  gtk_widget_show (rcvwin.vpaned);
  gtk_box_pack_start (GTK_BOX (rcvwin.vbox), rcvwin.vpaned, TRUE, TRUE, 0);

  rcvwin.scrolled = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (rcvwin.scrolled);
  gtk_container_add (GTK_CONTAINER (rcvwin.vpaned), rcvwin.scrolled);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (rcvwin.scrolled), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  gtk_widget_set_usize(GTK_PANED(rcvwin.vpaned)->child1, -1, 110);

  rcvwin.clist = gtk_clist_new (5);
  gtk_widget_show (rcvwin.clist);
  gtk_container_add (GTK_CONTAINER (rcvwin.scrolled), rcvwin.clist);
  gtk_clist_set_column_width (GTK_CLIST (rcvwin.clist), 0, 120);
  gtk_clist_set_column_width (GTK_CLIST (rcvwin.clist), 1, 160);
  gtk_clist_set_column_width (GTK_CLIST (rcvwin.clist), 2, 100);
  gtk_clist_set_column_width (GTK_CLIST (rcvwin.clist), 3, 15);
  gtk_clist_set_column_width (GTK_CLIST (rcvwin.clist), 4, 80);
  gtk_clist_column_titles_show (GTK_CLIST (rcvwin.clist));
  gtk_signal_connect (GTK_OBJECT(rcvwin.clist),"select_row",GTK_SIGNAL_FUNC(rcvwin_click),(gpointer)0);
  gtk_signal_connect (GTK_OBJECT(rcvwin.clist),"unselect_row",GTK_SIGNAL_FUNC(rcvwin_click),(gpointer)1);
  gtk_signal_connect (GTK_OBJECT(rcvwin.clist),"click_column",(GtkSignalFunc)clist_click_column,NULL);

  label = gtk_label_new ("from");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (rcvwin.clist), 0, label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new ("subject");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (rcvwin.clist), 1, label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new ("thread");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (rcvwin.clist), 2, label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new ("pri");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (rcvwin.clist), 3, label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new ("date");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (rcvwin.clist), 4, label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (rcvwin.vpaned), hbox1);

  rcvwin.text = gtk_text_new (NULL, NULL);
  gtk_widget_show (rcvwin.text);
  gtk_box_pack_start (GTK_BOX (hbox1), rcvwin.text, TRUE, TRUE, 0);
  gtk_text_set_editable (GTK_TEXT (rcvwin.text), FALSE);

  rcvwin.scrollbar = gtk_vscrollbar_new (GTK_TEXT(rcvwin.text)->vadj);
  gtk_widget_show (rcvwin.scrollbar);
  gtk_box_pack_start (GTK_BOX (hbox1), rcvwin.scrollbar, FALSE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start(GTK_BOX (rcvwin.vbox), hbox2, FALSE, TRUE, 0);

  rcvwin.but_close = gtk_button_new_with_label ("Close");
  gtk_widget_show (rcvwin.but_close);
  gtk_box_pack_end (GTK_BOX (hbox2), rcvwin.but_close, FALSE, TRUE, 0);
  gtk_widget_set_usize (rcvwin.but_close, 60, 25);

  rcvwin.but_remove = gtk_button_new_with_label ("Remove");
  gtk_widget_show (rcvwin.but_remove);
  gtk_box_pack_end (GTK_BOX (hbox2), rcvwin.but_remove, FALSE, TRUE, 0);
  gtk_widget_set_usize (rcvwin.but_close, 60, 25);

  rcvwin.but_next = gtk_button_new_with_label ("Next");
  gtk_widget_show (rcvwin.but_next);
  gtk_box_pack_end (GTK_BOX (hbox2), rcvwin.but_next, FALSE, TRUE, 0);
  gtk_widget_set_usize (rcvwin.but_next, 60, 25);

  rcvwin.but_prev = gtk_button_new_with_label ("Prev");
  gtk_widget_show (rcvwin.but_prev);
  gtk_box_pack_end (GTK_BOX (hbox2), rcvwin.but_prev, FALSE, TRUE, 0);
  gtk_widget_set_usize (rcvwin.but_prev, 60, 25);

  rcvwin.but_reply = gtk_button_new_with_label ("Reply");
  gtk_widget_show (rcvwin.but_reply);
  gtk_box_pack_start (GTK_BOX (hbox2), rcvwin.but_reply, FALSE, TRUE, 0);
  gtk_widget_set_usize (rcvwin.but_reply, 60, 25);

  rcvwin.but_forward = gtk_button_new_with_label ("Forward");
  gtk_widget_show (rcvwin.but_forward);
  gtk_box_pack_start (GTK_BOX (hbox2), rcvwin.but_forward, FALSE, TRUE, 0);
  gtk_widget_set_usize (rcvwin.but_forward, 60, 25);

  gtk_signal_connect_object(GTK_OBJECT(rcvwin.but_close),"clicked",GTK_SIGNAL_FUNC(gtk_widget_hide),(gpointer)rcvwin.win);
  gtk_signal_connect_object(GTK_OBJECT(rcvwin.but_remove),"clicked",GTK_SIGNAL_FUNC(rcvwin_func),(gpointer)0);
  gtk_signal_connect_object(GTK_OBJECT(rcvwin.but_reply),"clicked",GTK_SIGNAL_FUNC(rcvwin_func),(gpointer)1);
  gtk_signal_connect_object(GTK_OBJECT(rcvwin.but_forward),"clicked",GTK_SIGNAL_FUNC(rcvwin_func),(gpointer)2);
  gtk_signal_connect_object(GTK_OBJECT(rcvwin.but_prev),"clicked",GTK_SIGNAL_FUNC(rcvwin_func),(gpointer)3);
  gtk_signal_connect_object(GTK_OBJECT(rcvwin.but_next),"clicked",GTK_SIGNAL_FUNC(rcvwin_func),(gpointer)4);

	gtk_widget_set_sensitive(rcvwin.but_prev,FALSE);
	gtk_widget_set_sensitive(rcvwin.but_next,FALSE);

  gtk_widget_hide(rcvwin.win);
}


void rcvwin_func(int action)
{
msg_struct *m=NULL;
gint row=-1;
gint rows;

if (GTK_CLIST(rcvwin.clist)->selection!=NULL)
  row=(gint)(GTK_CLIST(rcvwin.clist)->selection->data);

if (row>-1) m=(msg_struct *)gtk_clist_get_row_data(GTK_CLIST(rcvwin.clist), row);
rows=GTK_CLIST(rcvwin.clist)->rows;

if ((action==0) && (row>-1))
  {
  free_msgstruct(m);
  gtk_clist_remove(GTK_CLIST(rcvwin.clist),row);

  gtk_text_freeze (GTK_TEXT(rcvwin.text));
  gtk_text_set_point(GTK_TEXT(rcvwin.text), 0);
  gtk_text_forward_delete(GTK_TEXT(rcvwin.text), gtk_text_get_length(GTK_TEXT(rcvwin.text)));
  gtk_text_thaw (GTK_TEXT(rcvwin.text));
  }
else if ((action==1) && (row>-1))
  {
  quote(m);
  }
else if ((action==2) && (row>-1))
  {
  forward_quote(m);
  }
else if ((action==3) && (rows>0) && (row>0))
  {
	row--;
	gtk_clist_select_row (GTK_CLIST(rcvwin.clist), row, 0);
	gtk_clist_moveto (GTK_CLIST(rcvwin.clist), row, 0, 0.5, 0);
  }
else if ((action==4) && (rows>0) && (row<rows))
  {
	row++;
	gtk_clist_select_row (GTK_CLIST(rcvwin.clist), row, 0);
	gtk_clist_moveto (GTK_CLIST(rcvwin.clist), row, 0, 0.5, 0);
  }
}


void rcvwin_click(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data)
{
char *uname=NULL;
GdkFont *normfont;
GdkFont *boldfont;
msg_struct *m;
int action;

  action=(gint)data;

  if (action==1) /* unselect_row */
	{
	gtk_widget_set_sensitive(rcvwin.but_reply,FALSE);
	gtk_widget_set_sensitive(rcvwin.but_forward,FALSE);
	gtk_widget_set_sensitive(rcvwin.but_remove,FALSE);
	gtk_widget_set_sensitive(rcvwin.but_prev,FALSE);
	gtk_widget_set_sensitive(rcvwin.but_next,TRUE);
	return;
	}
  
  gtk_widget_set_sensitive(rcvwin.but_reply,TRUE);
  gtk_widget_set_sensitive(rcvwin.but_forward,TRUE);
  gtk_widget_set_sensitive(rcvwin.but_remove,TRUE);
	if (row>0) gtk_widget_set_sensitive(rcvwin.but_prev,TRUE);
	if (row<(GTK_CLIST(rcvwin.clist)->rows)-1) gtk_widget_set_sensitive(rcvwin.but_next,TRUE);
																		    else gtk_widget_set_sensitive(rcvwin.but_next,FALSE);

  m=(msg_struct *)gtk_clist_get_row_data(GTK_CLIST(clist), row);
  gtk_clist_get_text(clist,row,0,&uname);

  gtk_text_freeze (GTK_TEXT(rcvwin.text));

  gtk_text_set_point(GTK_TEXT(rcvwin.text), 0);
  gtk_text_forward_delete(GTK_TEXT(rcvwin.text), gtk_text_get_length(GTK_TEXT(rcvwin.text)));

  normfont = gdk_font_load ("-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*");
  boldfont = gdk_font_load ("-adobe-courier-bold-r-normal--*-120-*-*-*-*-*-*");

  if (uname!=NULL)
	{
	gtk_text_insert(GTK_TEXT (rcvwin.text), boldfont, NULL, NULL, 
			   "\n    From: ", -1);
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   uname, -1);
	}
	
  if (m->thread!=NULL)
	{
	gtk_text_insert(GTK_TEXT (rcvwin.text), boldfont, NULL, NULL, 
			   "\n  Thread: ", -1);
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   m->thread, -1);
	}

  if (m->subj!=NULL)
	{
	gtk_text_insert(GTK_TEXT (rcvwin.text), boldfont, NULL, NULL, 
			   "\n Subject: ", -1);
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   m->subj, -1);
	}

  if (m->pri!=NULL)
	{
	gtk_text_insert(GTK_TEXT (rcvwin.text), boldfont, NULL, NULL, 
			   "\nPriority: ", -1);
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   m->pri, -1);
	}

  if (m->date!=NULL)
	{
	gtk_text_insert(GTK_TEXT (rcvwin.text), boldfont, NULL, NULL, 
			   "\n    Date: ", -1);
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   m->date, -1);
	}

  if (m->msg!=NULL)
	{
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   "\n\n", -1);
	gtk_text_insert(GTK_TEXT (rcvwin.text), normfont, NULL, NULL, 
			   m->msg, -1);
	}
	
  gdk_font_unref(boldfont);
  gdk_font_unref(normfont);

  gtk_text_thaw (GTK_TEXT(rcvwin.text));
}


void add_new_message_to_rcvwin(char *uid, char *nick, char *subj, char *thread, char *pri, char *text, char *tim)
{
char *buf=NULL;
char *a[5];
int row;
msg_struct *m;

  m=g_malloc(sizeof(msg_struct));
  m->fromid=g_strdup(uid);
  m->fromnick=g_strdup(nick);
  m->subj=g_strdup(subj);
  m->thread=g_strdup(thread);
  m->pri=g_strdup(pri);
  m->msg=g_strdup(text);
  m->date=g_strdup(tim);

  buf=strgrow(buf,uid,1,0);
  if (nick!=NULL)
	{
	buf=strgrow(buf," (",1,0);
	buf=strgrow(buf,nick,1,0);
	buf=strgrow(buf,")",1,0);
	}

  a[0]=buf;
  a[1]=subj;
  a[2]=thread;
  a[3]=pri;
  a[4]=tim;

  gtk_clist_freeze(GTK_CLIST(rcvwin.clist));
  row=gtk_clist_append(GTK_CLIST(rcvwin.clist), a);
  gtk_clist_set_row_data(GTK_CLIST(rcvwin.clist), row, (gpointer)m);
  gtk_clist_moveto (GTK_CLIST(rcvwin.clist), row, 0, 1, 0);
  gtk_clist_thaw(GTK_CLIST(rcvwin.clist));

	gtk_widget_set_sensitive(rcvwin.but_next,TRUE);

  g_free(buf);
}
