#include <gtk/gtk.h>
#include <stdio.h>

#ifdef GNOME
  #include <gnome.h>
#endif

#include "main.h"
#include "sendwin.h"
#include "events.h"
#include "gui.h"


sendwin_struct *create_sendwin(char *to, char *nick, char *thread, char *subj, char *msg, signed int pri)
{
  static sendwin_struct sendwin;
  GtkWidget *vbox1;
  GtkWidget *table1;
  GtkWidget *label;
  GtkObject *spin_pri_adj;
  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GtkWidget *vscrollbar1;

  to=g_strdup(to);
  nick=g_strdup(nick);
  thread=g_strdup(thread);
  subj=g_strdup(subj);
  msg=g_strdup(msg);
  
  sendwin.win = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_container_border_width (GTK_CONTAINER (sendwin.win), 3);
  gtk_window_set_title (GTK_WINDOW (sendwin.win), "Send message");
  gtk_window_position (GTK_WINDOW (sendwin.win), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (sendwin.win), TRUE, TRUE, FALSE);
  gtk_widget_set_usize(win, 160, 280);
  gtk_signal_connect (GTK_OBJECT(sendwin.win),"delete_event",GTK_SIGNAL_FUNC(delete_event),NULL);
/*  gtk_signal_connect_object (GTK_OBJECT(sendwin.win),"destroy",GTK_SIGNAL_FUNC(),sendwin.win);*/

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (sendwin.win), vbox1);

  table1 = gtk_table_new (3, 4, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox1), table1, TRUE, TRUE, 0);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 3);

  label = gtk_label_new ("To:");
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

  label = gtk_label_new ("Nick:");
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 2, 3, 0, 1,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

  label = gtk_label_new ("Subject:");
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

  label = gtk_label_new ("Thread:");
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

  sendwin.ent_to = gtk_entry_new ();
  gtk_widget_show (sendwin.ent_to);
  gtk_table_attach (GTK_TABLE (table1), sendwin.ent_to, 1, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

  sendwin.ent_subj = gtk_entry_new ();
  gtk_widget_show (sendwin.ent_subj);
  gtk_table_attach (GTK_TABLE (table1), sendwin.ent_subj, 1, 4, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_widget_set_usize (sendwin.ent_subj, 54, -1);

  sendwin.ent_thread = gtk_entry_new ();
  gtk_widget_show (sendwin.ent_thread);
  gtk_table_attach (GTK_TABLE (table1), sendwin.ent_thread, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

  spin_pri_adj = gtk_adjustment_new (1, -255, 255, 1, 10, 10);
  sendwin.spin_pri = gtk_spin_button_new (GTK_ADJUSTMENT (spin_pri_adj), 1, 0);
  gtk_widget_show (sendwin.spin_pri);
  gtk_table_attach (GTK_TABLE (table1), sendwin.spin_pri, 3, 4, 1, 2,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (sendwin.spin_pri), TRUE);

  sendwin.ent_nick = gtk_entry_new ();
  gtk_widget_show (sendwin.ent_nick);
  gtk_table_attach (GTK_TABLE (table1), sendwin.ent_nick, 3, 4, 0, 1,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_widget_set_usize (sendwin.ent_nick, 100, -1);

  label = gtk_label_new ("Priority:");
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 2, 3, 1, 2,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  sendwin.text = gtk_text_new (NULL, NULL);
  gtk_widget_show (sendwin.text);
  gtk_box_pack_start (GTK_BOX (hbox1), sendwin.text, TRUE, TRUE, 0);
  gtk_text_set_editable (GTK_TEXT (sendwin.text), TRUE);

  vscrollbar1 = gtk_vscrollbar_new (GTK_TEXT(sendwin.text)->vadj);
  gtk_widget_show (vscrollbar1);
  gtk_box_pack_start (GTK_BOX (hbox1), vscrollbar1, FALSE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start(GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);

  sendwin.but_close = gtk_button_new_with_label ("Close");
  gtk_widget_show (sendwin.but_close);
  gtk_box_pack_end (GTK_BOX (hbox2), sendwin.but_close, FALSE, TRUE, 0);
  gtk_widget_set_usize (sendwin.but_close, 60, 25);
  gtk_signal_connect_object(GTK_OBJECT(sendwin.but_close),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),(gpointer)(sendwin.win));

  sendwin.but_send = gtk_button_new_with_label ("Send");
  gtk_widget_show (sendwin.but_send);
  gtk_box_pack_end (GTK_BOX (hbox2), sendwin.but_send, FALSE, TRUE, 0);
  gtk_widget_set_usize (sendwin.but_send, 60, 25);
  gtk_signal_connect_object(GTK_OBJECT(sendwin.but_send),"clicked",GTK_SIGNAL_FUNC(sendwin_send),(gpointer)&sendwin);

  if (to!=NULL) gtk_entry_set_text(GTK_ENTRY(sendwin.ent_to),to);
  if (nick!=NULL) gtk_entry_set_text(GTK_ENTRY(sendwin.ent_nick),nick);
  if (thread!=NULL) gtk_entry_set_text(GTK_ENTRY(sendwin.ent_thread),thread);
  if (subj!=NULL) gtk_entry_set_text(GTK_ENTRY(sendwin.ent_subj),subj);
  if (msg!=NULL) gtk_text_insert(GTK_TEXT(sendwin.text), NULL, NULL, NULL, msg, -1);
  gtk_text_set_editable(GTK_TEXT(sendwin.text), TRUE);
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(sendwin.spin_pri), (gfloat)pri);

  gtk_widget_show(sendwin.win);

  g_free(to);
  g_free(nick);
  g_free(thread);
  g_free(subj);
  g_free(msg);

  return(&sendwin);
}

void sendwin_send(sendwin_struct *sendwin)
{
char *buf=NULL;
char *to, *nick, *thread, *subj, *msg;
signed int pri;

  to=gtk_entry_get_text(GTK_ENTRY(sendwin->ent_to));
  nick=gtk_entry_get_text(GTK_ENTRY(sendwin->ent_nick));
  subj=gtk_entry_get_text(GTK_ENTRY(sendwin->ent_subj));
  thread=gtk_entry_get_text(GTK_ENTRY(sendwin->ent_thread));
  pri=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(sendwin->spin_pri));
  msg=gtk_editable_get_chars(GTK_EDITABLE(GTK_TEXT(sendwin->text)),0,gtk_text_get_length(GTK_TEXT(sendwin->text)));

  if (strcmp(to,"")==0) return;

  buf=strgrow(buf,"<message><to",1,0);
  if (strcmp(nick,"")!=0)
	{
	buf=strgrow(buf," name='",1,0);
	buf=strgrow(buf,strescape(nick),1,1);
	buf=strgrow(buf,"'>",1,0);
	}
  else
	{
	buf=strgrow(buf,">",1,0);
	}

  buf=strgrow(buf,strescape(to),1,1);
  buf=strgrow(buf,"</to>",1,0);

  if (strcmp(thread,"")!=0)
	{
	buf=strgrow(buf,"<thread>",1,0);
	buf=strgrow(buf,strescape(thread),1,1);
	buf=strgrow(buf,"</thread>",1,0);
	}

{
char s[256];

	sprintf(s,"%d",pri);
  buf=strgrow(buf,"<priority>",1,0);
  buf=strgrow(buf,s,1,0);
  buf=strgrow(buf,"</priority>",1,0);
}

  if (strcmp(subj,"")!=0)
	{
    buf=strgrow(buf,"<subject>",1,0);
    buf=strgrow(buf,strescape(subj),1,1);
	buf=strgrow(buf,"</subject>",1,0);
	}

  if (strcmp(msg,"")!=0)
	{
    buf=strgrow(buf,"<say>",1,0);
	buf=strgrow(buf,strescape(msg),1,1);
    buf=strgrow(buf,"</say>",1,0);
	}

  buf=strgrow(buf,"</message>",1,0);

  send_data(buf);
  g_free(buf);  
  gtk_widget_destroy(sendwin->win);
}

