#include <stdio.h>
#include "common.h"
#include "mpair.h"
#include "ejpair.h"
#include "warper.h"
#include <glib.h>

void rcv_message(xpt *x, void (*handlefunc)(jpair *data))
{

if (strcasecmp(x->name,"message")==0)
  {
  xpt *chi;
  jpair *j=NULL;

  j=jpair_add(j, "type", strdescape(ejpair_getval(x->attributes, "type")));
  
  chi=x->children;
  while (chi!=NULL)
	{
	char *s=NULL;

	if (chi->name==NULL)
	  {
	  s=malloc(2);
	  strcpy(s,"");
	  }
	  else s=g_strdup(chi->name);

  if (chi->children!=NULL)
	{
  	if ((strcasecmp(s,"thread")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"thread",xpt2str_chain_also_unescape(chi));
  	else if ((strcasecmp(s,"subject")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"subject",xpt2str_chain_also_unescape(chi));
  	else if ((strcasecmp(s,"priority")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"priority",xpt2str_chain_also_unescape(chi));
  	else if ((strcasecmp(s,"say")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"msg",xpt2str_chain_also_unescape(chi));
  	else if ((strcasecmp(s,"ext")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"ext",xpt2str_chain_also_unescape(chi));
	else if ((strcasecmp(s,"from")==0) && (chi->type==XPT_TAG))
	  {
	  j=jpair_add(j,"fromid",xpt2str_chain_also_unescape(chi));
/*	j=jpair_add(j,"fromnick",strdescape(ejpair_getval(chi->attributes,"name"))); */
	  j=jpair_add(j,"fromnick",strdescape(ejpair_getval(chi->attributes,"nick")));
	  }
	fflush(stdout);
    }

	free(s);
	chi=chi->next;
	}

 (*handlefunc)(j);

  }
}


void rcv_status(xpt *x, void (*handlefunc)(jpair *data))
{
jpair *j=NULL;

if (strcasecmp(x->name,"status")==0)
  {
  xpt *chi;
  
  chi=x->children;
  while (chi!=NULL)
	{
	char *s=NULL;

	if (chi->name==NULL)
	  {
	  s=malloc(2);
	  strcpy(s,"");
	  }
	  else s=g_strdup(chi->name);

  if (chi->children!=NULL)
	{
	  j=jpair_add(j,"type",strdescape(ejpair_getval(x->attributes,"type")));
  	if ((strcasecmp(s,"priority")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"priority",xpt2str_chain_also_unescape(chi));
  	else if ((strcasecmp(s,"icon")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"icon",xpt2str_chain_also_unescape(chi));
  	else if ((strcasecmp(s,"say")==0) && (chi->type==XPT_TAG)) j=jpair_add(j,"msg",xpt2str_chain_also_unescape(chi));
	  else if ((strcasecmp(s,"from")==0) && (chi->type==XPT_TAG))
	  	{
	  	j=jpair_add(j,"fromid",xpt2str_chain_also_unescape(chi));
/*	  j=jpair_add(j,"fromnick",strdescape(ejpair_getval(chi->attributes,"name"))); */
	  	j=jpair_add(j,"fromnick",strdescape(ejpair_getval(chi->attributes,"nick")));
	  	}
	}

	free(s);
	chi=chi->next;
	}

  (*handlefunc)(j);
  
  }
}


void rcv_roster(xpt *x, void (*handlefunc)(jpair *data))
{

if (strcasecmp(x->name,"roster")==0)
  {
  xpt *chi;
  
  chi=x->children;
  while (chi!=NULL)
	{
	char *s=NULL;

	if (chi->name==NULL)
	  {
	  s=malloc(2);
	  strcpy(s,"");
	  }
	  else s=g_strdup(chi->name);

	if (strcasecmp(s,"group")==0)
	  {
	  jpair *j=NULL;

	  j=jpair_add(j,"groupname",strdescape(ejpair_getval(chi->attributes,"name")));
	  if (chi->children!=NULL) j=jpair_add(j,"userid",xpt2str_chain_also_unescape(chi));
	  (*handlefunc)(j);

	  }

	free(s);
	chi=chi->next;
	}
  }
}



void route_xml(xpt *x, mpair *wraphash, void(* unknowntag_func)(xpt *x))
{
char *s=NULL;

  while(x != NULL)
	{
	if(x->type != XPT_CDATA)
	  {
	  s=g_strdup(x->name);
	  
	  if (strcasecmp(s,"message")==0) rcv_message(x, mpair_getval(wraphash, x->name));
	  else if (strcasecmp(s,"status")==0) rcv_status(x, mpair_getval(wraphash, x->name));
	  else if (strcasecmp(s,"roster")==0) rcv_roster(x, mpair_getval(wraphash, x->name));
	  else (*unknowntag_func)(x);
	  
	  free(s);
	  }
	  x = x->next;
	}
}

char *xpt2str_chain_also_unescape(xpt *x)
{
char *t, *r;

t=xpt2str_chain(x->children);
r=strdescape(t);
g_free(t);
return(r);
}
