package org.jabber;

import java.net.*;
import java.io.*;
import java.util.*;

import org.jabber.packet.pipeline.*;

class ChannelConnected extends ChannelState {
	private Pipeline head = null;
public ChannelConnected(Pipeline head) {
	this.head = head;
}
public void connect(InetAddress host, int port) throws ConnectionException {
	throw new ConnectionException("Already connected");
}
public void disconnect() throws ConnectionException {
	try {
		head.close();
	} catch (IOException ioe) {
		throw new ConnectionException(ioe);
	} finally {
		getChannel().setState(new ChannelDisconnected());
	}
}
public Pipeline getPipeline() {
	return this.head;
}
public boolean isConnected() {
	return true;
}
}