package org.jabber;

import java.net.*;
import java.io.*;
import java.util.*;

import org.jabber.packet.Packet;
import org.jabber.packet.PacketFactory;
import org.jabber.packet.pipeline.Pipeline;

class ChannelDisconnected extends ChannelState {
public void buildConnection(Socket socket) throws ConnectionException {
	try {
		Pipeline head = PipelineBuilder.constructOn(socket);

		// Send a connection packet down the pipeline
		Packet conn = PacketFactory.instance().createConnectionPacket();
		System.out.println("Sending packet: " + conn);
		head.send(conn);

		// Read a packet from the pipeline
		Packet ack = head.receive();
		System.out.println("Packet received: " + ack);

		// It better be a connection packet.

		// Successful: change state to connected
		getChannel().setState(new ChannelConnected(head));
	} catch (IOException ioe) {
		throw new ConnectionException(ioe);
	}
}
public void connect(InetAddress host, int port) throws ConnectionException {
	try {
		// Create the socket
		Socket socket = new Socket(host, port);
		buildConnection(socket);
	} catch (IOException ioe) {
		throw new ConnectionException(ioe);
	}
}
}