package org.jabber.element;

import java.util.*;

public class Element {
	private String tag;
	private Vector attributes = new Vector();
	private Vector children = new Vector();
public Element(String tag) {
	this.tag = tag;
}
public void accept(ElementVisitor v) {
	v.visit(this);
}
public void add(Attribute attr) {
	attributes.addElement(attr);
}
public void add(Element elt) {
	children.addElement(elt);
}
public void addTextElement(String tagName, Object value) {
	if(value == null)
		return;

	add(new TextElement(tagName, value.toString()));
}
public void addTextElement(String tagName, String value) {
	if(value == null)
		return;

	add(new TextElement(tagName, value));
}
public Enumeration attributes() {
	return attributes.elements();
}
public Enumeration children() {
	return children.elements();
}
public String getTagName() {
	return this.tag;
}
public boolean isEmpty() {
	return children.size() == 0;
}
public void removeAttribute(Attribute attr) {
	attributes.removeElement(attr);
}
public void removeChild(Element elt) {
	children.removeElement(elt);
}
public void setTagName(String tagName) {
	this.tag = tagName;
}
}