package org.jabber.packet;

import org.jabber.*;

public class ConnectionPacket extends RawPacket {
	private String name;
	private String protocolVersion;
	private String clientVersion;

public ConnectionPacket(String name, String protocolVersion, String clientVersion) {
	this.name = name;
	this.protocolVersion = protocolVersion;
	this.clientVersion = clientVersion;
}
public void accept(PacketVisitor v) {
	v.visit(this);
}
public String getClientVersion() {
	return clientVersion;
}
public String getName() {
	return name;
}
public String getPacketType() {
	return PacketTypes.CONNECTION;
}
public String getProtocolVersion() {
	return protocolVersion;
}
public static ConnectionPacket prototype() {
	return new ConnectionPacket(null, null, null);
}
protected void setClientVersion(String ver) {
	this.clientVersion = ver;
}
protected void setName(String name) {
	this.name = name;
}
protected void setProtocolVersion(String ver) {
	this.protocolVersion = ver;
}
public void willSend() {
	StringBuffer sb = new StringBuffer("<jabber version=\"");
	sb.append(getName());
	sb.append("/JavaJabber/");
	sb.append(getClientVersion());
	sb.append("\" protocol=\"");
	sb.append(getProtocolVersion());
	sb.append("\">");
	setRawBytes(sb.toString().getBytes());
}
}