package org.jabber.packet;

import java.net.*;
import java.util.*;

public class PacketFactory implements org.jabber.Constants {
	private static PacketFactory _instance;
	private Hashtable packetPrototypes = null;
public Packet createConnectionPacket() throws UnknownHostException {
	return new ConnectionPacket(InetAddress.getLocalHost().getHostName(), PROTOCOL_VERSION, CLIENT_VERSION);
}
public Packet createMessagePacket(String from, String say) {
	return new MessagePacket(from, say);
}
protected static PacketFactory createPacketFactory() {
	// Simple implementation now, might get complex later
	return new PacketFactory();
}
public Packet createStatusPacket(String from, String say, Integer priority, String iconName) {
	return new StatusPacket(from, say, priority, iconName);
}
private Packet getPacketForType(String type) {
	Packet prototype = (Packet) getPacketPrototypes().get(type);
	return (Packet) prototype.clone();
}
private Hashtable getPacketPrototypes() {
	if (packetPrototypes != null) {
		return packetPrototypes;
	}
	
	packetPrototypes = new Hashtable();
	
	packetPrototypes.put(PacketTypes.CONNECTION, ConnectionPacket.prototype());
	packetPrototypes.put(PacketTypes.STATUS, StatusPacket.prototype());
	packetPrototypes.put(PacketTypes.LOGIN, LoginPacket.prototype());
	
	return packetPrototypes;
}
public static PacketFactory instance() {
	if (_instance == null) {
		_instance = createPacketFactory();
	}
	return _instance;
}
}