package org.jabber.packet;

public class StatusPacket extends Packet {
	private String from;
	private String say;
	private String icon;
	private Integer priority;
public StatusPacket(String from, String say, Integer priority, String icon) {
	this.from = from;
	this.say = say;
	this.priority = priority;
	this.icon = icon;
}
public void accept(PacketVisitor v) {
	v.visit(this);
}
public String getFrom() {
	return this.from;
}
public String getIconName() {
	return this.icon;
}
public String getPacketType() {
	return PacketTypes.STATUS;
}
public Integer getPriority() {
	return this.priority;
}
public String getSay() {
	return this.say;
}
public static StatusPacket prototype() {
	return new StatusPacket(null, null, null, null);
}
protected void setFrom(String from) {
	this.from = from;
}
protected void setIconName(String iconName) {
	this.icon = iconName;
}
protected void setPriority(Integer priority) {
	this.priority = priority;
}
protected void setSay(String say) {
	this.say = say;
}
}