package org.jabber.packet.pipeline;

import java.io.*;

import org.jabber.packet.*;

/** This is a "half-pipe".  It receives only.  Pair it with
 * a sending half-pipe using the PipeSplitter.
 */
public class InputStreamReceiver extends PipelineTail {
	private InputStream in;
public InputStreamReceiver(InputStream in) {
	this.in = in;
}
public void close() throws IOException {
	in.close();
}
protected RawPacket receiveRaw() throws IOException {
	RawPacket raw = new RawPacket();
	raw.setInputSource(in);
	return raw;
}
protected void sendRaw(RawPacket raw) throws IOException {
	throw new IOException("Cannot write to this half-pipe");
}
}