package org.jabber.packet.pipeline;

import java.io.*;

import org.jabber.packet.*;

/** This is a "half-pipe".  It sends only.  Pair it with
 * a reading half-pipe using the PipeSplitter.
 */
public class OutputStreamSender extends PipelineTail {
	private OutputStream out;
public OutputStreamSender(OutputStream out) {
	this.out = out;
}
public void close() throws IOException {
	out.close();
}
protected RawPacket receiveRaw() throws IOException {
	throw new IOException("Cannot read from this half-pipe");
}
protected void sendRaw(RawPacket raw) throws IOException {
	out.write(raw.getRawBytes());
	out.flush();
}
}