package org.jabber.packet.pipeline;

import java.io.*;

import org.jabber.packet.*;

public class PipeSplitter extends Pipeline {
	private Pipeline sender;
	private Pipeline receiver;
public PipeSplitter(Pipeline sender, Pipeline receiver) {
	this.sender = sender;
	this.receiver = receiver;
}
public void close() throws IOException {
	getSender().close();
	getReceiver().close();
}
public Pipeline getReceiver() {
	return this.receiver;
}
public Pipeline getSender() {
	return this.sender;
}
public Packet receive() throws IOException {
	return getReceiver().receive();
}
public void send(Packet p) throws IOException {
	getSender().send(p);
}
}