package org.jabber.packet.pipeline;

import java.io.*;

import org.jabber.packet.*;

/**
 * This segment of pipe goes at the end of the chain.
 * It sends RawPackets only, and it receives RawPackets.
 */
public abstract class PipelineTail extends Pipeline {
public Packet receive() throws IOException {
	return this.receiveRaw();
}
protected abstract RawPacket receiveRaw() throws IOException;
public void send(Packet p) throws IOException {
	if(!(p instanceof RawPacket)) {
		throw new IOException("PipelineTail subclasses only send raw packets");
	}
	this.sendRaw((RawPacket) p);
}
protected abstract void sendRaw(RawPacket raw) throws IOException;
}