package org.jabber.packet.pipeline;

import java.io.*;
import java.net.*;

import org.jabber.packet.*;

public class SocketSender extends PipelineTail {
	private Socket sock;
	private OutputStream output = null;
	private InputStream input = null;
public SocketSender(Socket s) {
	this.sock = s;
}
public void close() throws IOException {
	sock.close();
}
protected InputStream getInputStream() throws IOException {
	if (input == null) {
		input = getSocket().getInputStream();
	}
	return input;
}
protected OutputStream getOutputStream() throws IOException {
	if (output == null) {
		output = getSocket().getOutputStream();
	}
	return output;
}
public Socket getSocket() {
	return this.sock;
}
protected RawPacket receiveRaw() throws IOException {
	System.out.println(getClass().getName() + ".receive");
	
	RawPacket raw = new RawPacket();
	raw.setInputSource(getInputStream());
	return raw;
}
protected void sendRaw(RawPacket raw) throws IOException {
	getOutputStream().write(raw.getRawBytes());
	getOutputStream().flush();
}
public void setSocket(Socket s) {
	this.sock = s;
}
}