package org.jabber.packet.pipeline.test;

import java.io.*;

import junit.framework.*;

import org.jabber.packet.*;
import org.jabber.packet.pipeline.*;

public class InputStreamReceiverTest extends TestCase {
/**
 * InputStreamReceiverTest constructor comment.
 * @param name java.lang.String
 */
public InputStreamReceiverTest(String name) {
	super(name);
}
protected InputStreamReceiver createReceiver(String inputString) {
	return new InputStreamReceiver(new ByteArrayInputStream(inputString.getBytes()));
}
public static void main(java.lang.String[] args) {
	junit.textui.TestRunner.run(suite());
}
public static Test suite() {
	return new TestSuite(InputStreamReceiverTest.class);
}
public void testCannotSend() {
	String inputStream = "<status><say>Testing</say></status>";
	InputStreamReceiver receiver = createReceiver(inputStream);

	try {
		receiver.send(new RawPacket());

		assert(false);
	} catch(IOException ioe) {
		// OK
	}
}
public void testReceivingAnything() {
	String inputStream = "<status><say>Testing</say></status>";
	InputStreamReceiver receiver = createReceiver(inputStream);

	try {
		RawPacket p = (RawPacket)receiver.receive();

		assert(p.getRawBytes() != null);
	} catch(IOException ioe) {
		fail("Unexpected IOException: " + ioe);
	}
}
public void testReceivingFaithful() {
	String inputStream = "<status><say>Testing</say></status>";
	InputStreamReceiver receiver = createReceiver(inputStream);

	try {
		RawPacket p = (RawPacket)receiver.receive();

		assert(p.getRawBytes().equals(inputStream.getBytes()));
	} catch(IOException ioe) {
		fail("Unexpected IOException: " + ioe);
	}
}
public void testReceivingRaw() {
	String inputStream = "<status><say>Testing</say></status>";
	InputStreamReceiver receiver = createReceiver(inputStream);

	try {
		Packet p = receiver.receive();

		assert(p instanceof RawPacket);
	} catch(IOException ioe) {
		fail("Unexpected IOException: " + ioe);
	}
}
}