package org.jabber.packet.pipeline.test;

import java.io.*;

import junit.framework.*;

import org.jabber.packet.*;
import org.jabber.packet.pipeline.*;

public class OutputStreamSenderTest extends TestCase {
public OutputStreamSenderTest(String name) {
	super(name);
}
public static void main(java.lang.String[] args) {
	junit.textui.TestRunner.run(suite());
}
public static Test suite() {
	return new TestSuite(OutputStreamSenderTest.class);
}
public void testCannotReceive() {
	ByteArrayOutputStream out = new ByteArrayOutputStream();
	OutputStreamSender sender = new OutputStreamSender(out);

	try {
		sender.receive();

		assert(false);
	} catch(IOException ioe) {
		// OK
	}
}
public void testOnlySendsRaw() {
	ByteArrayOutputStream out = new ByteArrayOutputStream();
	OutputStreamSender sender = new OutputStreamSender(out);

	try {
		sender.send(new StatusPacket("from", "say", new Integer(5), "iconName"));
		assert(false);
	} catch(IOException ioe) {
		// Ok
	}

	try {
		sender.send(new LoginPacket("username", "nick"));
		assert(false);
	} catch(IOException ioe) {
		// Ok
	}
}
public void testSendsRaw() {
	ByteArrayOutputStream out = new ByteArrayOutputStream();
	OutputStreamSender sender = new OutputStreamSender(out);

	try {
		sender.send(new RawPacket("<say>foo</say>"));
	} catch(IOException ioe) {
		fail("Unexpected IOException: " + ioe);
	}
}
}