package org.jabber.packet.test;

import java.io.*;

import junit.framework.*;

import org.jabber.packet.*;
import org.jabber.packet.pipeline.*;

/**
 * This type was created in VisualAge.
 */
public abstract class PacketTest extends TestCase {
/**
 * PacketTestCase constructor comment.
 * @param name java.lang.String
 */
public PacketTest(String name) {
	super(name);
}
protected void checkRepresentation(Packet packet, String expected) {
	try {
		String buffer = stringifyPacket(packet);
		assert(buffer.equals(expected));
	} catch (IOException ioe) {
		fail("Exception: " + ioe.getMessage());
	}
}
protected String stringifyPacket(Packet status) throws IOException {
	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	
	// Tail first
	Pipeline sender = new OutputStreamSender(baos);
	Pipeline parse = new PacketParser(sender);
	Pipeline head = new PacketPreparer(parse);

	head.send(status);

	return baos.toString();
}
}