// MainFrm.cpp : implementation of the CMainFrame class
//

extern "C" {
#include "common.h"
}

#include "stdafx.h"
#include "MainFrm.h"
#include "JabberClient.h"
#include "ConnectDlg.h"
#include "NewMessage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	WM_ICON_NOTIFY			WM_USER+10


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_CONFIGURE, OnConfigure)
	ON_COMMAND(ID_CONNECT, OnConnect)
	ON_WM_TIMER()
	ON_COMMAND(ID_NEWMESSAGE, OnNewmessage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
	m_ServerSocket.SendData("</jabber>");
	Sleep(1000);
	m_ServerSocket.Close();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
	{
		AfxMessageBox("Failed CFrameWnd OnCreate!!");
		return -1;
	}
	
	// Create the tray icon
	if (!m_TrayIcon.Create(NULL,                            // Parent window
                           WM_ICON_NOTIFY,                  // Icon notify message to use
                           _T("JabberClient - Disconnected"),  // tooltip
                           ::LoadIcon(NULL, IDI_ASTERISK),  // Icon to use
                           IDR_POPUP_MENU))                 // ID of tray icon
	{
		AfxMessageBox("Failed to Create!");
		return -1;
	}

    m_TrayIcon.SetIcon(IDI_ICON1);

	AfxSocketInit();

	if(!m_ServerSocket.Init())
	{
		AfxMessageBox("ERROR: Cannot Create ServerSocket\n--\n" +
			CString(m_ServerSocket.GetLastError()));
	}

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame/CSystemTray menu message handlers

//void CMainFrame::OnPopupOption1() 
//{
//	MessageBox(_T("You chose Option 1"));	
//}



//void CMainFrame::OnPopupOption2() 
//{
	// TODO: Add your command handler code here
//	m_Option1Enabled = !m_Option1Enabled;

//	CString str;
//	str.Format(_T("You chose option 2. Option 1 is now %s"), 
//		m_Option1Enabled? _T("Enabled") : _T("Disabled"));

//	MessageBox(str);
	
//}

//void CMainFrame::OnPopupAnimate() 
//{
	// TODO: Add your command handler code here
//    m_TrayIcon.SetIconList(IDI_ICON1, IDI_ICON4);
//    m_TrayIcon.Animate(50,2);
//}

//void CMainFrame::OnPopupOption1() 
//{
	// TODO: Add your command handler code here
	
//}

//void CMainFrame::OnUpdatePopupOption1(CCmdUI* pCmdUI) 
//{
	// TODO: Add your command update UI handler code here
//	pCmdUI->Enable(m_Option1Enabled);
//}

void CMainFrame::OnConfigure() 
{
	// TODO: Add your command handler code here
	CConnectDlg dlg;
	dlg.m_AutoLogon = m_AutoLogon;
	dlg.m_Password = m_Password;
	dlg.m_ServerAddress = m_ServerAddress;
	dlg.m_UserName = m_UserName;

	int nResponse = dlg.DoModal();

	if(nResponse == IDOK)
	{
		m_AutoLogon = dlg.m_AutoLogon;
		m_Password = dlg.m_Password;
		m_ServerAddress = dlg.m_ServerAddress;
		m_UserName = dlg.m_UserName;
	}
	else if(nResponse == IDCANCEL)
	{
	}
}

void CMainFrame::OnConnect() 
{

	m_ServerSocket.xp = xpt_packet_new();

    m_TrayIcon.SetIconList(IDI_ICON1, IDI_ICON4);
    m_TrayIcon.Animate(250, 10);

	m_ServerSocket.Connect(m_ServerAddress, 5222);

	Sleep(1000);
    m_TrayIcon.StopAnimation();
    m_TrayIcon.SetIcon(IDI_ICON1);
	
	m_ServerSocket.SendData("<?xml version=\"1.0\"?>");
	m_ServerSocket.SendData("<jabber version = \"JabberClient/Win32/.01\" protocol=\"19990324\">\n");
	m_ServerSocket.SendData("<login>\n");
	m_ServerSocket.SendData("<user>" + m_UserName + "</user>");
	m_ServerSocket.SendData("<pass>" + m_Password + "</pass>");
	m_ServerSocket.SendData("<nick>Wolfie</nick>");
	m_ServerSocket.SendData("</login>\n");

	SetTimer(1, 1000, NULL);
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	m_ServerSocket.DoThings();
	
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnNewmessage() 
{
	// TODO: Add your command handler code here
	CNewMessage dlg;
	int nReturn = dlg.DoModal();
	if(nReturn == IDOK)
	{
		m_ServerSocket.SendData("<message><to>" +
			dlg.m_To + "</to><subject>" +
			dlg.m_Subject + "</subject><say>" +
			dlg.m_Say + "</say></message>\n\n");
	}
}
