// MessageHandler.cpp: implementation of the CMessageHandler class.
//
//////////////////////////////////////////////////////////////////////

extern "C"
{
#include "common.h"
}

#include "stdafx.h"
#include "jabberclient.h"
#include "JabberSocket.h"
#include "MessageDlg.h"
#include "MessageHandler.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMessageHandler::CMessageHandler(xpt * x)
{
	Active = TRUE;
	HandlePacket(x);
}

CMessageHandler::~CMessageHandler()
{

}

void CMessageHandler::HandlePacket(xpt * x)
{

	char *type;

	type = x->name;
	
	if(type == NULL)
	{
		AfxMessageBox("Umm, Null Packet Type?  WHO'S MESSIN with me??!!");
	}
	if(strcmp(type, "message") == 0)
		HandleMessage(x);
	Active = FALSE;
}

void CMessageHandler::HandleMessage(xpt * x)
{
	char *sub, *say, *ext, *thread, *pristr, *type, *from, *nick;
	int priority;
	xpt *next;

	if(x == NULL)
	{
		AfxMessageBox("Null xpt sent to HanndleMessage..  Ack!");
		return;
	}
	
	next = x->children;
	while(next != NULL)
	{
		if(next->type == XPT_TAG)
		{
			if(strcmp(next->name, "from") == 0)
				from = xpt2str_chain(next->children);
			if(strcmp(next->name, "subject") == 0)
				sub = xpt2str_chain(next->children);
			if(strcmp(next->name, "say") == 0)
				say = xpt2str_chain(next->children);
			if(strcmp(next->name, "ext") == 0)
				ext = xpt2str_chain(next->children);
			if(strcmp(next->name, "thread") == 0)
				thread = xpt2str_chain(next->children);
			if(strcmp(next->name, "priority") == 0)
			{
				pristr = xpt2str_chain(next->children);
				sscanf(pristr, "%d", priority);
			}
			next = next->next;
		}
	}
	CMessageDlg dlg;
	
	dlg.m_Say = CString(say);
	dlg.m_Subject = CString(sub);
	dlg.m_From = CString(from);

	dlg.DoModal();

}
