#
# Parser file for JabberLib
#      by Kerem 'Waster_' HADIMLI
#
# Contact me at waster@iname.com
#

proc XML:crypt {text} {
set retext ""
set cry1 {&amp;}
set cry2 {&lt;}
set cry3 {&gt;}
set cry4 {&quot;}
set cry5 {&apos;}

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char [string index $text $x]

    switch -- $char {
      & {set retext $retext$cry1}
      < {set retext $retext$cry2}
      > {set retext $retext$cry3}
      {"} {set retext $retext$cry4}
      ' {set retext $retext$cry5}
      default {set retext $retext$char}
      }
    }
  return $retext
}

proc XML:decrypt {text} {
set retext ""
set char ""
set cry1 {&amp;}
set cry2 {&lt;}
set cry3 {&gt;}
set cry4 {&quot;}
set cry5 {&apos;}

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char $char[string index $text $x]

    if { $char==$cry1 } {set retext $retext&; set char ""} \
      elseif { $char==$cry2 } {set retext $retext<; set char ""} \
      elseif { $char==$cry3 } {set retext $retext>; set char ""} \
      elseif { $char==$cry4 } {set retext $retext{"}; set char ""} \
      elseif { $char==$cry5 } {set retext $retext'; set char ""} \
        \
      elseif { "$char[rtrimleft $cry1 $char]"==$cry1 } {} \
      elseif { "$char[rtrimleft $cry2 $char]"==$cry2 } {} \
      elseif { "$char[rtrimleft $cry3 $char]"==$cry3 } {} \
      elseif { "$char[rtrimleft $cry4 $char]"==$cry4 } {} \
      elseif { "$char[rtrimleft $cry5 $char]"==$cry5 } {} \
      else { set retext $retext$char; set char "" }
    }
  return $retext
}

proc XML:extract {vars} {
set listvar ""
set varname ""
set value ""

set quotchar ""
set place1 ""
set place2 ""
set place3 ""
set tmp1 ""
set tmp2 ""

set tmp ""

while {$tmp==""} {
  if {[set place1 [findfirst "=" $vars 0]]==-1} {return $listvar}

  set varname [string range $vars 0 [expr $place1-1]]

  set tmp1 [findfirst {"} $vars $place1]
  set tmp2 [findfirst {'} $vars $place1]


  if {$tmp1<$tmp2 && $tmp1!="-1"} {set place2 $tmp1; set quotchar {"}} \
    elseif {$tmp1>$tmp2 && $tmp2=="-1"} {set place2 $tmp1; set quotchar {"}} \
    elseif {$tmp2<$tmp1 && $tmp2!="-1"} {set place2 $tmp2; set quotchar {'}} \
    elseif {$tmp2>$tmp1 && $tmp1=="-1"} {set place2 $tmp2; set quotchar {'}} \
    else {$listvar,line 81";return $listvar}



  if {$place2==-1} {return $listvar}

  if {[string trim [string range $vars [expr $place1+1] [expr $place2-1]]]!=""} {set vars [string range $vars [expr $place1+1] end]; continue}    ;#If there is something like {name=  abcd='aa'} ,skip name parameter

  incr place2
  set place3 [expr [findfirst $quotchar $vars $place2]-1]
  if {$place3==-2} {return $listvar}

  set varname [string trimleft $varname]
  set value [XML:decrypt [string range $vars $place2 $place3]]

  lappend listvar $varname
  lappend listvar $value

  set vars [string range $vars [expr $place3+2] end]
  }
}

proc XML:run {tag vars between command} {
#puts "XML:run -- tag:$tag vars:[XML:extract $vars]"
set vars [XML:extract $vars]
eval $command {$tag} {$vars} {$between}
}


proc XML:parse {text command} {

set index 0
set waitvar ""
#set level ""
set curlevel "0"
set look4end(0) ""
set tag1 ""
set tag2 ""
set tagstring ""
set tagend1 ""

while {$waitvar==""} {
    set tag1 [expr [findfirst "<" $text $index]+1]; set index $tag1; #set text [string range $text $tag1 end]
    set tag2 [expr [findfirst ">" $text $index]-1]; set index [expr $tag2+2]

    if {$tag1==0 || $tag2==-2} {return}
    set tag [string range $text $tag1 $tag2]

# Added for JabberLib
    if {[string index $tag 0]=="/" && [rtrimleft $tag "/"]=="jabber"} {
      JabberLib:EndOfParse
      continue
    }
# /Added for JabberLib

    if {$look4end($curlevel)==1 && [string index $tag 0]=="/" && [rtrimleft $tag "/"]==$level(tagname,$curlevel)} {
      if {$curlevel==1} {XML:run $level(tagname,$curlevel) $level(tagvars,$curlevel) [string range $text $tagend1 [expr $tag1-2]] $command}
      set curlevel [expr $curlevel-1]
    } elseif {$look4end($curlevel)==1 && [string index $tag 0]=="/" && [rtrimleft $tag "/"]!=$level(tagname,$curlevel)} {
    } else {

      incr curlevel
      set level(tagname,$curlevel) ""; scan $tag "%s" level(tagname,$curlevel)
      set level(tagvars,$curlevel) [rtrimleft $tag "$level(tagname,$curlevel) "]

      set level(tagname,$curlevel) $level(tagname,$curlevel)

# Added for JabberLib
      if {$level(tagname,$curlevel)=="?xml" && [string index $tag [expr [string length $tag]-1]]=="?" && $curlevel==1} {
        set $level(tagvars,$curlevel) [string range $level(tagvars,$curlevel) 0 [expr [string length $level(tagvars,$curlevel)]-2]]
        XML:run $level(tagname,$curlevel) $level(tagvars,$curlevel) "" $command
        set curlevel [expr $curlevel-1]
        continue
      }
# /Added for JabberLib

# Added for JabberLib
      if {$level(tagname,$curlevel)=="jabber" && $curlevel==1} {
        XML:run $level(tagname,$curlevel) $level(tagvars,$curlevel) "" $command
        set curlevel [expr $curlevel-1]
        continue
      }
# /Added for JabberLib

      if {[string range $tag end end]=="/" } {
        set tag [string range $tag 0 [expr [string length $tag]-2]]

        set level(tagname,$curlevel) ""; scan $tag "%s" level(tagname,$curlevel)
        set level(tagvars,$curlevel) [rtrimleft $tag "$level(tagname,$curlevel) "]

        if {$curlevel==1} {XML:run $level(tagname,$curlevel) $level(tagvars,$curlevel) "" $command}
        set curlevel [expr $curlevel-1]
      } else {
        set look4end($curlevel) 1
        if {$curlevel==1} {set tagend1 [expr $tag2+2]}
      }
    }
  }
}

proc rtrimleft {bigstr srcstr} {
set istring1 [string length $srcstr]
if {$srcstr == [string range $bigstr 0 [expr $istring1-1]]} {
  return [string range $bigstr $istring1 end] }
}

proc findfirst {srcstr bigstr start} {
set text [string range $bigstr $start end]
if {[set index [string first $srcstr $text]]!=-1} \
  {return [expr $start+$index]} else {return -1}
}
