source ./INIparse/iniparse.tcl

set cfile "config.ini"
set config(list) {Happy Programming Playing Eating Normal Away Sad Angry}
set config(old)  {Happy}
set config(now)  ""

proc loadconfig {} {
global jabber cfile

set jabber(username) [readini $cfile login]
set jabber(pass) [readini $cfile pass]
set jabber(nick) [readini $cfile nick]
set jabber(server) [readini $cfile server]

set jabber(msgs,happy) [readini $cfile msgs_happy]
set jabber(msgs,programming) [readini $cfile msgs_programming]
set jabber(msgs,playing) [readini $cfile msgs_playing]
set jabber(msgs,eating) [readini $cfile msgs_eating]
set jabber(msgs,normal) [readini $cfile msgs_normal]
set jabber(msgs,away) [readini $cfile msgs_away]
set jabber(msgs,sad) [readini $cfile msgs_sad]
set jabber(msgs,angry) [readini $cfile msgs_angry]

set jabber(win,geom_mainwin) [readini $cfile geom_mainwin]
set jabber(win,geom_sendwin) [readini $cfile geom_sendwin]
set jabber(win,geom_receiwin) [readini $cfile geom_receiwin]
}

proc save_geom_mainwin {} {
global cfile
writeini $cfile geom_mainwin [wm geometry .win]
}

proc save_geom_sendwin {w} {
global cfile jabber
set jabber(win,geom_sendwin) [wm geometry $w]
writeini $cfile geom_sendwin $jabber(win,geom_sendwin)
}

proc save_geom_receiwin {w} {
global cfile jabber
set jabber(win,geom_receiwin) [wm geometry $w]
writeini $cfile geom_receiwin $jabber(win,geom_receiwin)
}

proc configwindow {} {
global cfile config jabber

  set config(msgs,Happy)       $jabber(msgs,happy)
  set config(msgs,Programming) $jabber(msgs,programming)
  set config(msgs,Playing)     $jabber(msgs,playing)
  set config(msgs,Eating)      $jabber(msgs,eating)
  set config(msgs,Normal)      $jabber(msgs,normal)
  set config(msgs,Away)        $jabber(msgs,away)
  set config(msgs,Sad)         $jabber(msgs,sad)
  set config(msgs,Angry)       $jabber(msgs,angry)

    set base ".confwin"

    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 300x250
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm maxsize $base 400 300
    wm deiconify $base
    wm transient $base .
    wm title $base "Configure"
    grab set $base
    focus $base

    Notebook:create $base.n -pages {Login Messages Misc} -width 1 -height 1
    set f1 [Notebook:frame $base.n "Login"]
    set f2 [Notebook:frame $base.n "Messages"]
    set f3 [Notebook:frame $base.n "Misc"]

    Notebook:pageconfig $base.n Login -onexit {{
			if {[.confwin.n.f0.servname get]==""} {tk_messageBox -parent .confwin -title "Error" -message "You must enter a server address!"; return 0}
			if {[.confwin.n.f0.logname get]==""} {tk_messageBox -parent .confwin -title "Error" -message "You must enter a login name!"; return 0}
			if {[.confwin.n.f0.password get]==""} {tk_messageBox -parent .confwin -title "Error" -message "You must enter a password!"; return 0}
			}}
    frame $f1.f -relief sunken -borderwidth 1
    frame $f2.f -relief sunken -borderwidth 1
    frame $f3.f -relief sunken -borderwidth 1
    button $f1.f.b1 -borderwidth 1 -text Ok -command "config:save $f1 $f2 $f3; destroy $base"
    button $f2.f.b1 -borderwidth 1 -text Ok -command "config:save $f1 $f2 $f3; destroy $base"
    button $f3.f.b1 -borderwidth 1 -text Ok -command "config:save $f1 $f2 $f3; destroy $base"
    button $f1.f.b2 -borderwidth 1 -text Cancel -command "destroy $base"
    button $f2.f.b2 -borderwidth 1 -text Cancel -command "destroy $base"
    button $f3.f.b2 -borderwidth 1 -text Cancel -command "destroy $base"
    button $f1.f.b3 -borderwidth 1 -text Help
    button $f2.f.b3 -borderwidth 1 -text Help
    button $f3.f.b3 -borderwidth 1 -text Help

    pack $base.n -expand 1 -fill both -ipadx 10 -ipady 10
    place $f1.f -x [expr 266-66] -y 0 -width 66 -height 62
    place $f2.f -x [expr 266-66] -y 0 -width 66 -height 62
    place $f3.f -x [expr 266-66] -y 0 -width 66 -height 62
    place $f1.f.b1 -x 0 -y 0 -width 64 -height 20
    place $f2.f.b1 -x 0 -y 0 -width 64 -height 20
    place $f3.f.b1 -x 0 -y 0 -width 64 -height 20
    place $f1.f.b2 -x 0 -y 20 -width 64 -height 20
    place $f2.f.b2 -x 0 -y 20 -width 64 -height 20
    place $f3.f.b2 -x 0 -y 20 -width 64 -height 20
    place $f1.f.b3 -x 0 -y 40 -width 64 -height 20
    place $f2.f.b3 -x 0 -y 40 -width 64 -height 20
    place $f3.f.b3 -x 0 -y 40 -width 64 -height 20


    ################
    # Page 1
    ################

    entry $f1.logname -width 0
    entry $f1.servname -width 0
    entry $f1.password -width 0 -show "*"
    entry $f1.nickname -width 0
    message $f1.mes1 -text "Please enter your\naccount information" -justify center -aspect 5000
    message $f1.mes2 -text "Username:" -aspect 5000
    message $f1.mes3 -text "Server:" -aspect 5000
    message $f1.mes4 -text "@" -aspect 5000
    message $f1.mes5 -text "Password:" -aspect 5000
    message $f1.mes6 -text "Nickname:" -aspect 5000

    place $f1.logname -x 0 -y 80 -width 96 -height 19
    place $f1.servname -x 110 -y 80 -width 146 -height 19
    place $f1.password -x 70 -y 110 -width 186 -height 19
    place $f1.nickname -x 70 -y 135 -width 186 -height 19
    place $f1.mes1 -x 25 -y 15
    place $f1.mes2 -x -5 -y 65 -width 65 -height 11
    place $f1.mes3 -x 105 -y 65 -width 48 -height 11
    place $f1.mes4 -x 95 -y 80 -width 15 -height 21
    place $f1.mes5 -x -5 -y 110
    place $f1.mes6 -x -5 -y 135

    $f1.logname insert 0 $jabber(username)
    $f1.servname insert 0 $jabber(server)
    $f1.password insert 0 $jabber(pass)
    $f1.nickname insert 0 $jabber(nick)

    ################
    # Page 2
    ################

    text     $f2.t     -width 1 -height 1 -background #ffffff
    message  $f2.mes   -aspect 5000 -text {Select message to customize:}
    $f2.t insert end $config(msgs,Happy)
    combobox $f2.combo -width 1 -value [lindex $config(list) 0] -textvariable config(now) \
	-command {
		if {$config(now)==""} {return}
		set abc [.confwin.n.f1.t get 1.0 end]
		set config(msgs,$config(old)) [string range $abc 0 [expr [string length $abc]-2]]
		.confwin.n.f1.t delete 1.0 end
		.confwin.n.f1.t insert end $config(msgs,$config(now))
		set config(old) $config(now)
	}

    foreach abc $config(list) {$f2.combo list insert end $abc}

    place $f2.t     -x 0 -y 75 -width 266 -height 108
    place $f2.mes   -x 0 -y 5 -width 158 -height 21
    place $f2.combo -x 25 -y 35 -width 96 -height 19
}

proc config:save {f1 f2 f3} {
global cfile config jabber

  ##################
  # Save Page1
  ##################

  if {[set a1 [$f1.servname get]]==""} {tk_messageBox -parent .confwin -title "Error" -message "You must enter a server address!"; return}
  if {[set a2 [$f1.logname  get]]==""} {tk_messageBox -parent .confwin -title "Error" -message "You must enter a login name!"; return}
  if {[set a3 [$f1.password get]]==""} {tk_messageBox -parent .confwin -title "Error" -message "You must enter a password!"; return}
  set a4 [$f1.nickname get]

  if {$a1!=$jabber(server)}   {set jabber(server)   $a1; writeini $cfile server $a1}
  if {$a2!=$jabber(username)} {set jabber(username) $a2; writeini $cfile login  $a2}
  if {$a3!=$jabber(pass)}     {set jabber(pass)     $a3; writeini $cfile pass   $a3}
  if {$a4!=$jabber(nick)}     {set jabber(nick)     $a4; writeini $cfile nick   $a4}

  ##################
  # Save Page2
  ##################

  set abc [$f2.t get 1.0 end]
  set config(msgs,$config(now)) [string range $abc 0 [expr [string length $abc]-2]]

  if {$jabber(msgs,happy)!=$config(msgs,Happy)} {set jabber(msgs,happy) $config(msgs,Happy); writeini $cfile msgs_happy $jabber(msgs,happy)}
  if {$jabber(msgs,programming)!=$config(msgs,Programming)} {set jabber(msgs,programming) $config(msgs,Programming); writeini $cfile msgs_programming $jabber(msgs,programming)}
  if {$jabber(msgs,playing)!=$config(msgs,Playing)} {set jabber(msgs,playing) $config(msgs,Playing); writeini $cfile msgs_playing $jabber(msgs,playing)}
  if {$jabber(msgs,eating)!=$config(msgs,Eating)} {set jabber(msgs,eating) $config(msgs,Eating); writeini $cfile msgs_eating $jabber(msgs,eating)}
  if {$jabber(msgs,normal)!=$config(msgs,Normal)} {set jabber(msgs,normal) $config(msgs,Normal); writeini $cfile msgs_normal $jabber(msgs,normal)}
  if {$jabber(msgs,away)!=$config(msgs,Away)} {set jabber(msgs,away) $config(msgs,Away); writeini $cfile msgs_away $jabber(msgs,away)}
  if {$jabber(msgs,sad)!=$config(msgs,Sad)} {set jabber(msgs,sad) $config(msgs,Sad); writeini $cfile msgs_sad $jabber(msgs,sad)}
  if {$jabber(msgs,angry)!=$config(msgs,Angry)} {set jabber(msgs,angry) $config(msgs,Angry); writeini $cfile msgs_angry $jabber(msgs,angry)}

}

#
# Proc to crypt "enter" chars used in cfg file.
#
proc cfgcrypt {text} {
set retext ""
set cry1 {_;}
set cry2 {__}

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char [string index $text $x]

    switch -- $char {
      "\n" {set retext $retext$cry1}
      "_"  {set retext $retext$cry2}
      default {set retext $retext$char}
      }
    }
  return $retext
}

#
# Proc to decrypt "enter" chars used in cfg file.
#
proc cfgdecrypt {text} {
set retext ""
set char ""
set cry1 {_;}
set cry_1 "\n"
set cry2 {__}
set cry_2 "_"

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char $char[string index $text $x]

    if { $char==$cry1 } {set retext $retext$cry_1; set char ""} \
      elseif { $char==$cry2 } {set retext $retext$cry_2; set char ""} \
        \
      elseif { "$char[rtrimleft $cry1 $char]"==$cry1 } {} \
      elseif { "$char[rtrimleft $cry2 $char]"==$cry2 } {} \
      else { set retext $retext$char; set char "" }
    }
  return $retext
}
