proc client:jabber:server {protocol version} {}

proc zabber:connect {} {
global jabber

  .win.f0.men25 configure -text "Connecting..."
  update idletasks
  if {[JabberLib:jabber:connect $jabber(server) "zABBER test version 1.1" \
		$jabber(username) $jabber(nick) $jabber(pass)]==-1} {

	set jabber(status) "offline"
	.win.f0.men25 configure -text Offline
	tk_messageBox -message "An error occured while trying to connect $jabber(server)\nPlease check your connection" -parent .win
	return
  }

  .win.m.roster entryconfigure 0 -state normal
  .win.m.roster entryconfigure 5 -state normal

  JabberLib:roster:reget

# We souldn't send our status when we connect...
# JabberLib:change:status $jabber(status) "This is my status" $jabber(priority) $jabber(condition)

  switch -- $jabber(status) {
	online  {.win.f0.men25 configure -text Online}
	OFFLINE {.win.f0.men25 configure -text Privacy}
	offline {.win.f0.men25 configure -text Offline}
  }

}

proc zabber:disconnect {} {
global jabber JabberLib

  #We first delete everything in our widget
  foreach group $JabberLib(roster,groups) {Tree:delitem .win.f.tree "/$group"}

  JabberLib:jabber:disconnect

  .win.m.roster entryconfigure 0 -state disabled
  .win.m.roster entryconfigure 5 -state disabled

  set jabber(status) "offline"
  .win.f0.men25 configure -text "Offline"
}

proc client:jabber:offline {} {
global jabber

tk_messageBox -message "Server $jabber(server) closed connection."

set jabber(status) "offline"
.win.f0.men25 configure -text Offline
}

proc zabber:deluser {user group} {
  if {[tk_messageBox -icon question -parent .win -type yesno -title "Delete User" \
       -message "Are you sure you want to delete this user?"]=="no"} {return}

  JabberLib:roster:deluser $group $user
  Tree:delitem .win.f.tree "/$group/$user"
}

proc zabber:delgroup {group} {
  if {[tk_messageBox -icon question -parent .win -type yesno -title "Delete Group" \
       -message "Are you sure you want to delete this group?"]=="no"} {return}

  JabberLib:roster:delgroup $group
  Tree:delitem .win.f.tree "/$group"
}

proc client:roster:group {group} {
global JabberLib
	catch {Tree:newitem .win.f.tree "/$group"}
#
# Move tree 1 units down, to avoid space above text
#
	if {[llength $JabberLib(roster,groups)]==1} {.win.f.tree yview scroll 1 units}
}

proc client:roster:user {group user} {
global JabberLib

	catch {Tree:newitem .win.f.tree "/$group/$user"}

	foreach nick $JabberLib(roster,users,$user) {
		#   Here we send a "nick" command so the nicks under
		# user (if the user already in another group) are updated

		client:roster:nick $user $nick [JabberLib:roster:getinfo $user $nick]
	}
}

proc client:roster:nick {user nick prop} {
global JabberLib

set type [lindex $prop 0]
set msg  [lindex $prop 1]
set pri  [lindex $prop 2]
set icon [lindex $prop 3]


	foreach a $JabberLib(roster,groups) {
		if {[lsearch $JabberLib(roster,groups,$a) $user]!=-1} {
			if {$type=="offline"} {
					catch {Tree:newitem .win.f.tree /$a/$user/$nick -image idisconnect} ;#We try to create a new nick under Tree Widget in case there isn't
					Tree:cfgitem .win.f.tree /$a/$user/$nick -image idisconnect
					return} \
				elseif {$type=="online"} {catch {Tree:newitem .win.f.tree /$a/$user/$nick -image iconnect}}
		}
	}

	foreach a $JabberLib(roster,groups) {
		if {[lsearch $JabberLib(roster,groups,$a) $user]!=-1} {
			if {$icon=="happy"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image ihappy} \
				elseif {$icon=="programming"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iprogramming} \
				elseif {$icon=="playing"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iplaying} \
				elseif {$icon=="eating"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image ieating} \
				elseif {$icon=="normal"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iconnect} \
				elseif {$icon=="away"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iaway} \
				elseif {$icon=="sad"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image isad} \
				elseif {$icon=="angry"} {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iangry} \
				else {Tree:cfgitem .win.f.tree /$a/$user/$nick -image iconnect}
		}
	}
}

proc client:msg:error {from subject msg ext} {
global jabber
errorwin .mes$jabber(mesnum) $subject $msg
incr jabber(mesnum)
}

proc client:msg:normal {from nick subject thread pri message} {
global jabber

lappend abc $nick
lappend abc $subject
lappend abc $thread
lappend abc $pri
lappend abc $message

if {[info exists jabber(messages,$from)]=="0"} {set jabber(messages,$from) ""}
set jabber(messages,$from) [linsert $jabber(messages,$from) 0 $abc]

receivewin $from "new"
}

proc rtrimleft {bigstr srcstr} {
set istring1 [string length $srcstr]
if {$srcstr == [string range $bigstr 0 [expr $istring1-1]]} {
  return [string range $bigstr $istring1 end] }
}
proc findfirst {srcstr bigstr start} {
set text [string range $bigstr $start end]
if {[set index [string first $srcstr $text]]!=-1} \
  {return [expr $start+$index]} else {return -1}
}

proc findlast {srcstr bigstr end} {
set text [string range $bigstr 0 $end]
if {[set index [string last $srcstr $text]]!=-1} \
  {return $index} else {return -1}
}
proc zabber:sendmsg {base} {
  set to [split [$base.f0.f0.to get] ","] ;#Here we accept multiple "to"s separated with commas
  set nick [$base.f0.f0.nick get]
  set thread [$base.f0.f0.thread get]
  set priority [$base.f0.f0.pri get]
  set subject [$base.f0.f1.subject get]
  set message [$base.f1.text get 1.0 end]

  JabberLib:send:message $to $nick $subject $thread $priority $message
}

#
# Priority sort for tree widget
# Returns -1, 0, or 1 depending on the values
#
proc zabber:prisort {user nick1 nick2} {
global JabberLib

  set pri1 [lindex $JabberLib(roster,users,$user,$nick1) 2]
  set pri2 [lindex $JabberLib(roster,users,$user,$nick2) 2]

  if {$pri1<$pri2 && $pri1>-1} {return -1} \
    elseif {$pri1<$pri2 && $pri1<0} {return 1} \
    elseif {$pri1>$pri2 && $pri2>-1} {return 1} \
    elseif {$pri1>$pri2 && $pri2<0} {return -1} \
    elseif {$pri1==$pri2} {return 0}
}

#
# Changes the given message to replied form (each line starting with "> ")
#
proc zabber:replymsg {mes from} {
set startchar "> "
set endchar "\n"
set newmes "\n     $from wrote:\n"

  foreach a [split $mes \{"\n"\}] {set newmes $newmes$startchar$a$endchar}
  return $newmes
}
