#!/usr/local/bin/perl
# Dan DeMaggio <dmag@umich.edu> 
# Usage:
#  startup server/jabberbox and server/jabber.transport, then this code.
#  in another window, run the jabber client and message foo@perl

use IO::Select;
use IO::Socket;

$jabberbox = new IO::Socket::INET(PeerAddr => '127.0.0.1', PeerPort => 5269, Proto => 'tcp');
die "Can't create socket" unless $jabberbox;
$jabberbox->autoflush(1);

$ready = new IO::Select($jabberbox);
die "Can't select" unless $ready;

# Tell them we're here
$jabberbox->print(<<EOF) || die($!);
<ether>
<handshake>perl</handshake>
<alias>perl</alias>
EOF

while (1) # to infinity and beyond
{
  if ($ready->can_read(1.25)) # seconds before timeout.
  {
    my $temp;
    $jabberbox->sysread($temp,1024);
    $buffer .= $temp;  #debug: print $temp;
    parse();
  }
  print "... the waiting is the hardest part ...\n"; 
}


sub parse
{
  if ($buffer =~ s!([\d\D]+>)!!) # this should be non-greedy
  {                  # but I'm too lazy to look it up right now.
    print "** Getting message from jabberbox:\n";
    print "$1\n";
    print "** Thank you Mr. Server\n";
  }
}

__EOF__
