#include <stdio.h>
#include "element.h"

void printelement(element e, int tabcnt)
{
     int i;
     if (e == NULL)
	  return;
     for (i = 0; i < tabcnt; i++)
	  putchar('\t');
     switch(e->type)
     {
     case ETYPE_ATTRIB: printf("Attribute: %s = %s\n", e->name, e->data); break;
     case ETYPE_TAG:    printf("Tag: %s\n", e->name); break;
     case ETYPE_CDATA:  printf("CDATA: %s\n", e->data); break;
     }
     if (e->attribs != NULL)
	  printelement(e->attribs, tabcnt +1);
     if (e->firstchild != NULL)
	  printelement(e->firstchild, tabcnt+1);
     printelement(element_next(e), tabcnt+1);
}
     

int main ()
{
     element e,a,b,c; 
     char* newstr;
     e = element_new("roster",ETYPE_TAG);
     a = element_new_child(e, "add", ETYPE_TAG);
     b = element_new_child(a, "", ETYPE_CDATA);
     element_set_data(b,"<ABC>123</ABC>");
     element_put_attrib(a,"name", "dave");
          
     c = element_lastchild(a);
     if (element_type(c) == ETYPE_CDATA)
     {
	  newstr = (char*)malloc(strlen(element_data(c)) + strlen("<MORE>TAGS</MORE>" + 1));
	  strncpy(newstr, "<MORE>TAGS</MORE>", strlen("<MORE>TAGS</MORE>"));
	  strcat(newstr, element_data(c));
	  element_set_data(c, newstr);
     }

     printelement(e,0);

}

