// laim_contacts.cpp
// handles contacts (buddies) for core
// LAIM
// Copyright (C) 1998 Jae Jang <akubi@stones.com>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// ------------------------------------------------------------            
// each person in buddy list is an object of class Contact
// each person not in buddy list is infact a member of the list
// but with status hidden
#include "laim_core.h"

string foo2lsn(string SN);

extern string word_to_str(unsigned short);
Contacts contact;	// class containing a double linked list with various
					// supporting methods.

Contact::Contact()
{
	proto_id = AIM;
	screen_name = "";
	alias = "";
	status = offline;
	group = 0;
}

Contact::Contact(IM_type I, string SN, string nick, Status stat, int grp)
{
	proto_id = I;
	screen_name = SN;
	alias = SN;
	status = stat;
	group = grp;
}

string Contact::send_IM(string msg)
{
	SNAC_packet S_pkt(0x04, 0x06, 0x00, 0x00, 0x2718);
	unsigned short Len = 0x0001;
	switch (proto_id) {
		case AIM :
			S_pkt.data = word_to_str(0x74d5) + word_to_str(0xb1ad)
				+ word_to_str(0xaa1d) + word_to_str(0xd21a);
			S_pkt.data += word_to_str(0x0001);
			unsigned char len;
			len = screen_name.length();
			S_pkt.data += len;
			S_pkt.data += screen_name;
			S_pkt.data += word_to_str(0x0002);
			// 0x0001 is L in TLV
			S_pkt.data += word_to_str( (msg.length() + 0x0c + Len) );
			S_pkt.data += word_to_str(0x0501);
			S_pkt.data += word_to_str(Len);
			// now for L 0x01 (byte)s followed by 0x0101 (word)
			// Java: L=1, AIM 2.0 beta: L=3
			for (unsigned short i = 1; i <= Len; i++) 
				S_pkt.data += 0x01;
			S_pkt.data += word_to_str(0x0101);
			S_pkt.data += word_to_str( (msg.length() + 0x04) );
			S_pkt.data += word_to_str(0x0000) + word_to_str(0x0000);
			S_pkt.data += msg;
			return S_pkt.packet();
		default :
			return "";
	}
}

string Contact::get_profile()
{
	SNAC_packet S_pkt(0x02, 0x05, 0x00, 0x00, 0x2719);
	char len = screen_name.length();
	switch (proto_id) {
		case AIM :
			S_pkt.data = word_to_str(0x0001) + len + screen_name;
			return S_pkt.packet();
		default :
			return "";
	}
}

string search_by_email(IM_type I, string email)
{
	SNAC_packet S_pkt(0x0a, 0x02, 0x00, 0x00, 0x2720);
	switch (I) {
		case AIM :
			S_pkt.data = email;
			return S_pkt.packet();
		default :
			return "";
	}
}
	
void Contacts::add(IM_type I, string SN, string nick, Status stat, int grp)
{
	Contact tmp(I, SN, nick, stat, grp);
	person.push_back(tmp);
}

// add with nick==SN, stat==offline, grp==0
void Contacts::add(IM_type I, string SN)
{
	Contact tmp(I, SN, SN, offline, 0);
	if (I == GHOST)
		tmp.status = hidden;
	person.push_back(tmp);
}

void Contacts::del(string SN)
{
	C_LI it = find_contact_iter(SN);
	person.erase(it);
}

C_LI Contacts::find_contact_iter(string SN)
{
	for (C_LI i = person.begin(); i != person.end(); ++i) {
		Contact& c = *i;	// reference used as shorthand;
		if ( foo2lsn(SN) == foo2lsn(c.alias)  )
			return i;
	}
#ifdef LAIM_DEBUG
	cerr << "Not found" << endl;
#endif
	return person.end();
}

Contact* Contacts::find_contact(string SN)
{
	for (C_LI i = person.begin(); i != person.end(); ++i) {
		Contact& c = *i;	// reference used as shorthand;
		if ( foo2lsn(SN) == foo2lsn(c.alias) )
			return &c;
	}
#ifdef LAIM_DEBUG
	cerr << "Not found setting return value to ghost" << endl;
#endif
	C_LI i = person.end();
	--i;
	Contact& c = *i;
	return &c;
}

Contact* Contacts::updated()
{
	return last_mod;
}

void Contacts::update(Contact* c)
{
	last_mod = c;
}

string foo2lsn(string SN) {
        string alias = "";
        for (int j = 0; j < SN.length(); j++) {  // yet more kludge, this is
		if ( !isblank(SN[j]) )	 // actually Jae's Code - shorti @apci.net */
                  alias += tolower(SN[j]);
        }
	return (alias);
}
