// laim_core.cpp
// (some core routines)
// LAIM
// Copyright (C) 1998 Jae Jang <akubi@stones.com>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// ------------------------------------------------------------            
#include <iostream.h>
// socket related includes
#include <errno.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <fcntl.h>
#include "laim_core.h"
#include <cstdlib>

string word_to_str(unsigned short i)
{
	char foo, bar;
	string r;
	// the following is a workaround... should only work on intel (other
	// Least Sig byte platforms) i think. ^_^;; tell me if I'm wrong.
	foo = (i & 0xFF00) >> 8;
	bar = (i & 0x00FF);
	r = foo;
	r += bar;
	return r;
}

void IM_session::init()
{
	struct sockaddr_in my_addr;
	struct hostent*	he;
	// get user's home directory (In unix) for later use
	// it is NOT / terminated.
	home_dir = getenv("HOME");
	// DNS lookup
#ifdef LAIM_DEBUG
	cerr << "LAIM. LAIM's An Instant Messenger" << endl;
	cerr << "Core Version: " << LAIM_MAJOR_VERSION << '.' << 
		LAIM_MINOR_VERSION << '.' << LAIM_BUILD << endl;
	cerr << "Copyright (c)1998 Jae Jang <akubi@stones.com>" << endl <<endl;
	cerr << "looking up domain name server..." << endl;
#endif
	if ( (he = gethostbyname(server_ip.c_str())) == NULL) {
#ifdef LAIM_DEBUG
		cerr << "failed to look up login.oscar.aol.com" << endl;
#endif
		herror("gethostbyname");
		exit(1);
	}
	// do "standard" bsd-socket opening crap
	// mostly from beej's socket programming tutorial
	socket_num = socket(AF_INET, SOCK_STREAM, 0);
	my_addr.sin_family = AF_INET;
	my_addr.sin_port = htons(server_port);
	my_addr.sin_addr = *((struct in_addr *)he->h_addr);
	bzero(&(my_addr.sin_zero), 8);
	
#ifdef LAIM_DEBUG
	cerr << "contacting host " << server_ip << ':' << server_port << endl;
#endif
	if (connect(socket_num,(struct sockaddr *)&my_addr, sizeof(struct
		sockaddr)) == -1) {
		perror("connect");
		exit(1);
	}
#ifdef LAIM_DEBUG
	cerr << "socket opened... initiating login sequence\n";
#endif

	// do AIM/ICQ_session.login();
}

// (un)sets socket_num as (NON)blocking
// set to blocking if patient (p==true)
// set to non blocking if impatient (p==false)
void IM_session::patient(bool p)
{
	if (!p) {
		fcntl(socket_num, F_SETFL, O_NONBLOCK);
	}
}

int IM_session::get_socket_num()
{
	return socket_num;
}
