/*
  aim_auth.c

  Deals with the authorizer.

 */

#include "aim.h"

#if 0
/* this appears to be a duplicate! */
u_long aim_requestservice(int serviceid)
{
  struct command_tx_struct newpacket;
  
  newpacket.lock = 1;
  newpacket.conn = aim_getconn_type(AIM_CONN_TYPE_BOS);
  newpacket.type = 0x0002;
  
  newpacket.commandlen = 12;
  newpacket.data = (char *) malloc(newpacket.commandlen);

  newpacket.data[0] = 0x00;
  newpacket.data[1] = 0x01;

  newpacket.data[2] = 0x00;
  newpacket.data[3] = 0x04;

  newpacket.data[4] = 0x01;
  newpacket.data[5] = 0x01;

  /* SNAC reqid */
  newpacket.data[6] = (aim_snac_nextid >> 24) & 0xFF;
  newpacket.data[7] = (aim_snac_nextid >> 16) & 0xFF;
  newpacket.data[8] = (aim_snac_nextid >>  8) & 0xFF;
  newpacket.data[9] = (aim_snac_nextid) & 0xFF;

  newpacket.data[10] = (serviceid>>8)&0xFF;
  newpacket.data[11] = (serviceid)&0xFF;

  aim_tx_enqueue(&newpacket);

  {
    struct aim_snac_t snac;
    
    snac.id = aim_snac_nextid;
    snac.family = 0x0001;
    snac.type = 0x0004;
    snac.flags = 0x0000;

    snac.data = malloc(sizeof(int));
    *((int *)snac.data) = serviceid;

    aim_newsnac(&snac);
  }

  return (aim_snac_nextid++);
}
#endif

/* this just pushes the passed cookie onto the passed connection -- NO SNAC! */
int aim_auth_sendcookie(struct aim_conn_t *conn, char *chipsahoy)
{
  struct command_tx_struct newpacket;
  
  newpacket.lock = 1;

  if (conn==NULL)
    newpacket.conn = aim_getconn_type(AIM_CONN_TYPE_AUTH);
  else
    newpacket.conn = conn;

  newpacket.type = 0x0001;  /* channel 1 (no SNACs, you know) */
  
  newpacket.commandlen = 4 + 2 + 2 + 0x100;
  newpacket.data = (char *) malloc(newpacket.commandlen);

  newpacket.data[0] = 0x00;
  newpacket.data[1] = 0x00;

  newpacket.data[2] = 0x00;
  newpacket.data[3] = 0x01;

  newpacket.data[4] = 0x00;
  newpacket.data[5] = 0x06;
  newpacket.data[6] = 0x01;
  newpacket.data[7] = 0x00;

  memcpy(&(newpacket.data[8]), chipsahoy, 0x100);

  aim_tx_enqueue(&newpacket);
  
  return 0;
}

u_long aim_auth_clientready(struct aim_conn_t *conn)
{
  struct command_tx_struct newpacket;
  
  newpacket.lock = 1;

  if (conn==NULL)
    newpacket.conn = aim_getconn_type(AIM_CONN_TYPE_AUTH);
  else
    newpacket.conn = conn;

  newpacket.type = 0x0002;
  
  newpacket.commandlen = 26;
  newpacket.data = (char *) malloc(newpacket.commandlen);

  newpacket.data[0] = 0x00;
  newpacket.data[1] = 0x01;

  newpacket.data[2] = 0x00;
  newpacket.data[3] = 0x02;

  newpacket.data[4] = 0x00;
  newpacket.data[5] = 0x00;

  /* SNAC reqid */
  newpacket.data[6] = (aim_snac_nextid >> 24) & 0xFF;
  newpacket.data[7] = (aim_snac_nextid >> 16) & 0xFF;
  newpacket.data[8] = (aim_snac_nextid >>  8) & 0xFF;
  newpacket.data[9] = (aim_snac_nextid) & 0xFF;

  newpacket.data[10] = 0x00;
  newpacket.data[11] = 0x01;
  newpacket.data[12] = 0x00;
  newpacket.data[13] = 0x02;
  newpacket.data[14] = 0x00;
  newpacket.data[15] = 0x01;
  newpacket.data[16] = 0x00;
  newpacket.data[17] = 0x13;
  newpacket.data[18] = 0x00;
  newpacket.data[19] = 0x07;
  newpacket.data[20] = 0x00;
  newpacket.data[21] = 0x01;
  newpacket.data[22] = 0x00;
  newpacket.data[23] = 0x01;
  newpacket.data[24] = 0x00;
  newpacket.data[25] = 0x01;

  aim_tx_enqueue(&newpacket);

  {
    struct aim_snac_t snac;
    
    snac.id = aim_snac_nextid;
    snac.family = 0x0001;
    snac.type = 0x0004;
    snac.flags = 0x0000;

    snac.data = NULL;

    aim_newsnac(&snac);
  }

  return (aim_snac_nextid++);
}

u_long aim_auth_changepasswd(struct aim_conn_t *conn, char *new, char *current)
{
  struct command_tx_struct newpacket;
  int i;

  newpacket.lock = 1;

  if (conn==NULL)
    newpacket.conn = aim_getconn_type(AIM_CONN_TYPE_AUTH);
  else
    newpacket.conn = conn;

  newpacket.type = 0x0002;
  
  newpacket.commandlen = 10 + 4 + strlen(current) + 4 + strlen(new);
  newpacket.data = (char *) malloc(newpacket.commandlen);

  newpacket.data[0] = 0x00;
  newpacket.data[1] = 0x07;

  newpacket.data[2] = 0x00;
  newpacket.data[3] = 0x04;

  newpacket.data[4] = 0x00;
  newpacket.data[5] = 0x00;

  /* SNAC reqid */
  newpacket.data[6] = (aim_snac_nextid >> 24) & 0xFF;
  newpacket.data[7] = (aim_snac_nextid >> 16) & 0xFF;
  newpacket.data[8] = (aim_snac_nextid >>  8) & 0xFF;
  newpacket.data[9] = (aim_snac_nextid) & 0xFF;

  /* current password TLV t(0002) */
  i = 10;
  newpacket.data[i++] = 0x00;
  newpacket.data[i++] = 0x02;
  newpacket.data[i++] = 0x00;
  newpacket.data[i++] = strlen(current) & 0xff;
  memcpy(&(newpacket.data[i]), current, strlen(current));
  i += strlen(current);

  /* new password TLV t(0012) */
  newpacket.data[i++] = 0x00;
  newpacket.data[i++] = 0x12;
  newpacket.data[i++] = 0x00;
  newpacket.data[i++] = strlen(new) & 0xff;
  memcpy(&(newpacket.data[i]), new, strlen(new));
  i+=strlen(new);

  aim_tx_enqueue(&newpacket);

  {
    struct aim_snac_t snac;
    
    snac.id = aim_snac_nextid;
    snac.family = 0x0001;
    snac.type = 0x0004;
    snac.flags = 0x0000;

    snac.data = NULL;

    aim_newsnac(&snac);
  }

  return (aim_snac_nextid++);
}
