/*
  aim_logoff.c

  All the routines needed to logoff, if there are any.

 */

#include "aim.h"

/* 
   aimlogoff(int socket)
   
   This tells AIM to take use off the usage lists and off the BuddyLists.
   It appears there's no response or acknowledgment of this command from
   the server.

   I think this is pointless.  You get the same result by just closing
   the socket to the server.
   
*/
int aim_logoff(void)
{
  int i = AIM_CONN_MAX;
  while (i > -1)
    {
      if (aim_conns[i].fd>-1)
	aim_conn_close(&(aim_conns[i]));
      i--;
    }
  aim_connrst();  /* in case we want to connect again */

  return 0;

}
