#include "icqt.h"

void config_init()
{
  if (jpair_get(etc.arg, "-local") != NULL)
    etc.vars = jpair_new(etc.vars, "local", jpair_getval(etc.arg, "-local"), 0);
  else
    etc.vars = jpair_new(etc.vars, "local", DEFAULT_ETHERX, 0);
  if (jpair_get(etc.arg, "-errorlog") != NULL)
    etc.vars = jpair_new(etc.vars, "errorlog", jpair_getval(etc.arg, "-errorlog"), 0);
  else
    etc.vars = jpair_new(etc.vars, "errorlog", DEFAULT_LOG, 0);
}


void config_handle(xpt * x)
{
  xpt *next;
  jpair *last, *j, *p;
  conn *c;
  char *str;

  j = xpt2jpair(x);
  /* append all the vars in the config section to etc.vars */
  if (j != NULL)
  {
    last = j;
    while (last->next != NULL)
      last = last->next;
    last->next = etc.vars;
    etc.vars = j;
  }

  next = x;
  while (next != NULL)
  {

    if (next->type == XPT_TAG && strcmp(next->name, "users") == 0)
      users_initialize(next->children);
    next = next->next;
  }


  if (jpair_get(etc.vars, "name") == NULL)
    etc.vars = jpair_new(etc.vars, "name", "ICQ", 0);

  str = make_tag_quick("alias", jpair_getval(etc.vars, "name"));
  etc.transport->packets = packet_add(etc.transport->packets, str, NULL);
  free(str);
}


void users_initialize(xpt * x)
{
  xpt *next;
  int uin;
  char *id, *pass;

  next = x;
  while (next != NULL)
  {
    if (next->type == XPT_TAG)
    {
      id = xpt2str_chain(next->children);
      pass = jpair_getval(next->attributes, "pass");
      sscanf(jpair_getval(next->attributes, "uin"), "%d", &uin);
      etc.users = jpair_new(etc.users, id, pass, uin);
    }
    next = next->next;
  }
}

void config_help()
{
  char *str;

  /* need to print right version, PACKAGE or whatever */
  printf("icq transport\n");
  printf("Usage:\n");
  printf("\t-D enable debugging info to STDOUT\n");
  printf("\t-? this screen\n");
}
