#include "icqt.h"

void icq_main()
{
  char buffer[1024];
  int len, count, more;
  packet *p;

  count = 0;
  more = 1;
  while (1)
  {
    ICQ_Check_Response(10000);

    len = read(etc.transport->id, buffer, 1023);
    if (len > 0)
    {
      buffer[len] = '\0';
      dispatch(buffer, etc.transport, IO_NORMAL);
    }

    while(etc.transport->packets != NULL && more == 1)
    {
      len = write(etc.transport->id, etc.transport->packets->data + etc.transport->packets->sent, strlen(etc.transport->packets->data) - etc.transport->packets->sent);
      if (len < 0)
      {
        DBG_MSG("connection to transport dies");
	exit(0);
      }
      if ((len + etc.transport->packets->sent) == strlen(etc.transport->packets->data))
      {
	/* this packets empty, crush and move on */
	p = etc.transport->packets->next;
	free_packet(etc.transport->packets);
	etc.transport->packets = p;
        more = 1;
      }
      else
      {
	etc.transport->packets->sent += len;
        more = 0; /* for some reason we cant write it all, try again later */
      }
    }

    sleep(1);
    if (count > 100)
    {
      count = 1;
      if(etc.status == JSTATUS_ONLINE)
        ICQ_Keep_Alive();
    }
    count++;
  }
}

void icq_handle_packet(conn * c, xpt * x)
{
  xpt *xml, *next;
  char *val = NULL;
  char *type;

  DBG_VAL("handling_icq_packet", c->name);

  type = x->name;
  if (type == NULL)		/* not a valid incoming packet */
  {
    return;
  }

  /* stringpieces->string->xpt to make sure we get xpt in the end */
  next = x->children;
  while (next != NULL)
  {
    if (next->type == XPT_CDATA)
      val = strgrow(val, next->value, 1, 0);
    next = next->next;
  }
  DBG_VAL("transport_packet", val);

  xml = xpt_str(val);
  free(val);

  if (NULL == xml)
  {
    ERROR("template", "Got some bad XML!");
    return;
  }

  if (strcmp(x->name, "r") == 0)
  {
    DBG_MSG("Handling remote packet from transport");
    if (strcmp(xml->name, "message") == 0)
      handle_message(c, xml);
    if (strcmp(xml->name, "status") == 0)
      handle_status(c, xml);
    free_xpt(xml);
    return;
  }

  if (strcmp(x->name, "error") == 0)
  {
    DBG_MSG("Handling bounced packet from transport");
    free_xpt(xml);
    return;
  }

  if (strcmp(x->name, "config") == 0)	/* ignore in the fork */
    return;

  syslog_debug(SYSLOG_ERROR, "etherx", "unknown_packet", x->name);
}

void AddContact(int uin)
{
  int i;
  for (i = 0; i < Num_Contacts; i++)
  {
    if (Contacts[i].uin == uin)
      return;
  }
  Contacts[Num_Contacts].uin = uin;
  strcpy(Contacts[Num_Contacts].nick, "NewUser");
  Contacts[Num_Contacts].status = STATUS_OFFLINE;
  Contacts[Num_Contacts].last_time = -1L;
  Contacts[Num_Contacts].current_ip = -1L;
  Contacts[Num_Contacts].port = -1L;
  Contacts[Num_Contacts].sok = 0;
  Contacts[Num_Contacts].connected = 0;
  Num_Contacts++;
  Send_ContactList();
}

void EventLogin(void *data)
{
  printf("ICQLogin\n");
}

void EventDisconnect(void *data)
{
  printf("ICQDisconnect\n");
}

void EventMessage(void *data)
{
  CLIENT_MESSAGE_PTR c_mesg;
  char uin[20];

  printf("ICQMessage\n");
  c_mesg = (CLIENT_MESSAGE_PTR) data;
  sprintf(uin, "%d", c_mesg->uin);
  switch (c_mesg->type)
  {
  case URL_MESS:
    c_mesg->url;
    c_mesg->msg;
    break;
  case AWAY_MESS:
    c_mesg->msg;
  default:
    c_mesg->msg;
    break;
  }
  printf("Received[%s] from [%s]\n", c_mesg->msg, uin);
  deliver_message(uin, "", etc.user, NULL, "ICQ message", c_mesg->msg, NULL, NULL, 0, NULL);
  AddContact(c_mesg->uin);
}

void EventChangeStatus(void *data)
{
  char uin[20];
  USER_UPDATE_PTR user_update;

  user_update = (USER_UPDATE_PTR) data;

  printf("ICQChangeStatus\n");
  sprintf(uin, "%d", user_update->uin);
  printf("Received status from [%d][%s]\n", user_update->uin, user_update->nick);
  status_update(uin, user_update->nick, etc.user, user_update->status, NULL, NULL, NULL, 0);
}

void EventSearchResults(void *data)
{
  printf("ICQSearch Results\n");
}

void EventInfo(void *data)
{
  printf("ICQInfo\n");
}

void EventExtInfo(void *data)
{
  printf("ICQExt Info\n");
}
