#include "icqt.h"

void handle_message(conn * c, xpt * x)
{
  jpair *to, *jnext;
  char *from_user, *from_nick, *sub, *say, *ext, *thread, *pristr, *type;
  int priority, uin;
  xpt *next, *next2;

  DBG_MSG("handle_message");

  if (c == NULL || x == NULL)
    return;

  to = NULL;
  from_user = jpair_getvalnew(x->attributes, "from");
  from_nick = jpair_getvalnew(x->attributes, "nick");
  if (from_user == NULL)
  {
    DBG_MSG("Invalid message, improper from");
    return;
  }

  pristr = sub = say = ext = thread = NULL;
  priority = 0;

  type = jpair_getvalnew(x->attributes, "type");

  next = x->children;
  while (next != NULL)
  {
    if (next->type == XPT_TAG && strcmp(next->name, "to") == 0)
      to = jpair_add(to, xpt2str_chain(next->children), jpair_getvalnew(next->attributes, "nick"));
    if (next->type == XPT_TAG && strcmp(next->name, "subject") == 0)
      sub = xpt2str_chain(next->children);
    if (next->type == XPT_TAG && strcmp(next->name, "say") == 0)
      say = xpt2str_chain(next->children);
    if (next->type == XPT_TAG && strcmp(next->name, "thread") == 0)
      thread = xpt2str_chain(next->children);
    if (next->type == XPT_TAG && strcmp(next->name, "ext") == 0)
    {
      next2 = next->children;
      ext = NULL;
      while (next2 != NULL)
      {
	ext = strgrow(ext, xpt2str(next2), 1, 1);
	next2 = next2->next;
      }
    }
    if (next->type == XPT_TAG && strcmp(next->name, "priority") == 0)
    {
      pristr = xpt2str_chain(next->children);
      sscanf(pristr, "%d", &priority);
    }
    next = next->next;
  }

  if(etc.status != JSTATUS_ONLINE)
    status_update(from_user, from_nick, to->key, STATUS_ONLINE, NULL, NULL, NULL, 0);

  jnext = to;
  while (jnext != NULL)
  {
    sscanf(jnext->key,"%d",&uin);
    printf("Forwarding to [%d] message [%s]\n",uin,say);
    AddContact(uin);
    say = strrepl(say, "\n", "\r\n");
    ICQ_Send_Message(uin, say);
    jnext = jnext->next;
  }

  free(from_user);
  free(from_nick);
  free_jpair(to);
  free(sub);
  free(say);
  free(ext);
  free(thread);
  free(pristr);
  free(type);
}


void deliver_message(char *from_user,
		     char *from_nick,
		     char *to_user,
		     char *to_nick,
		     char *subject,
		     char *say,
		     char *thread,
		     char *ext,
		     int priority,
		     char *type)
{
  xpt *parent, *x;
  char intbuff[20], *server, *str;
  conn *c = NULL;
  jpair *par;

  if (to_user == NULL)		/*WTF? */
    return;

  parent = xpt_new_tag(NULL, "message", NULL);

  if (type != NULL)
    parent->attributes = jpair_new(parent->attributes, "type", type, 0);

  if (subject != NULL)
  {
    x = xpt_new_tag(parent, "subject", NULL);
    xpt_new_cdata(x, subject);
  }

  if (say != NULL)
  {
    x = xpt_new_tag(parent, "say", NULL);
    xpt_new_cdata(x, say);
  }

  if (thread != NULL)
  {
    x = xpt_new_tag(parent, "thread", NULL);
    xpt_new_cdata(x, thread);
  }

  if (ext != NULL)
  {
    x = xpt_new_tag(parent, "ext", NULL);
    xpt_new_cdata(x, ext);
    x->children->name = strdup("NOESCAPE");	/* kludge so that it isn't escaped automatically */
  }

  if (priority != 0)
  {
    x = xpt_new_tag(parent, "priority", NULL);
    sprintf(intbuff, "%d", priority);
    xpt_new_cdata(x, intbuff);
  }


  DBG_VAL("message", xpt2str(parent));

  transport_deliver(from_user, from_nick, to_user, to_nick, parent);

  free_xpt(parent);
}
