/* gcc -o icqtransport prototype.c libcommon.a libicq.a libglib.a -I/home/jeremie/jabber/jabber/lib -I/usr/lib/glib/include */
/* 1667467 */
#include <stdio.h>
#include <unistd.h>

#include <glib.h>

#include "common.h"
#include "icq.h"
#include "libicq.h"

#define STATUS_NORMAL -10

conn *transport;
jpair *arg;
jpair *sessions;

void RegisterCallbacks();
void status_update(char *user, char *nick, char *to, int status, char *say, char *icon, char *ext, int priority);
void handle_status(xpt *x);
void deliver_message(char *from_user,char *from_nick,char *to_user,char *to_nick,char *subject,char *say,char *thread,char *ext,int priority,char *type);
void handle_message(xpt *x);
char *create_packet(char *name, jpair *atts, char *body);
void transport_deliver(char *from_user, char *from_nick, char *to_user, char *to_nick, xpt *x);
void handle_packet(xpt *x);
void AddContact(int uin);

int main(int argc, char *argv[])
{
	int sock, len, count;
	char buffer[1024];
	xptpool *xp;
	xpt *next, *xml;
	packet *p;

	arg = arg2jpair(argc,argv);
	if(jpair_get(arg,"-uin") == NULL || jpair_get(arg,"-secret") == NULL || jpair_get(arg,"-name") == NULL || jpair_get(arg,"-for") == NULL)
	{
		printf("Usage:\n./icqtransport -name \"ICQ\" -uin 123456 -secret \"myICQpass\" -for \"jabberid@server\"\n");
		exit(0);
	}

	RegisterCallbacks();
	ICQ_Debug(ICQ_VERB_INFO);

	sscanf(jpair_getval(arg,"-uin"),"%d",&UIN);
	strcpy(passwd,jpair_getval(arg,"-secret"));
	set_status = STATUS_ONLINE;
	strcpy(server,"icq.mirabilis.com");
	remote_port = 4000;
	Num_Contacts = 0;

	sock = make_netsocket(5269, "127.0.0.1", 1);
	if(sock < 0)
	{
		printf("Unable to connect to etherx, make sure etherx is running on localhost!\n");
		exit(0);
	}
	fcntl(sock,F_SETFL,O_NONBLOCK);
	transport = conn_add(NULL, sock);
	transport->packets = packet_add(transport->packets,"<?xml version='1.0'?><ether><alias>",NULL);
	transport->packets = packet_add(transport->packets,jpair_getval(arg,"-name"),NULL);
	transport->packets = packet_add(transport->packets,"</alias>",NULL);

	sessions = NULL;
/*	ICQ_Change_Status(STATUS_ONLINE);*/

	xp = xpt_packet_new();
	count = 1;
	while(1)
	{
		printf(".");

		ICQ_Check_Response(10000);

		len = read(transport->id, buffer, 1023);
		if(len > 0)
		{
			buffer[len] = '\0';
			printf("Decoding data[%s]\n",buffer);
			xpt_packet_data(xp,buffer,len);
			next = xml = xp->packets;
			while(next != NULL)
			{
				xml = next;
				next = next->next;
				xml->next = NULL; /* single it out */
				handle_packet(xml);
			}
			free_xpt(xp->packets);
			xp->packets = NULL;
			if(xp->flag != XPT_POOLFLAG_NONE)
			{
				switch(xp->flag)
				{
					case XPT_POOLFLAG_ERROR:
						printf("Invalid XML from etherx!\n");
						break;
					case XPT_POOLFLAG_CLOSE:
						printf("Session closed from etherx!\n");
						break;
					default:
						printf("Unknown XML error from etherx!\n");
				}
				return 0;
			}
		}


		if(transport->packets != NULL)
		{
			len = write(transport->id, transport->packets->data + transport->packets->sent, strlen(transport->packets->data) - transport->packets->sent);
			if(len < 0)
			{
				printf("Connection to etherx broke!\n");
				return 0;
			}
			if((len + transport->packets->sent) == strlen(transport->packets->data))
			{
				/* this packets empty, crush and move on */
				p = transport->packets->next;
				free_packet(transport->packets);
				transport->packets = p;
			}else{
				transport->packets->sent += len;
			}
		}


		sleep(1);
		if(count > 100)
		{
			count = 1;
			ICQ_Keep_Alive();
		}
		count++;
	}

}

/*	ICQ_Send_Message(1631999, "test");*/

static void EventLogin(void* data)
{
	printf("ICQLogin\n");
}
static void EventDisconnect(void* data)
{
	printf("ICQDisconnect\n");
}
static void EventMessage(void* data)
{
	CLIENT_MESSAGE_PTR c_mesg;
	char uin[20];

	printf("ICQMessage\n");
	c_mesg = (CLIENT_MESSAGE_PTR)data;
	sprintf(uin, "%d", c_mesg->uin);
	switch(c_mesg->type)
	{
		case URL_MESS:
			c_mesg->url;
			c_mesg->msg;
			break;
		case AWAY_MESS:
			c_mesg->msg;			
		default:
			c_mesg->msg;
			break;
	}
	printf("Received[%s] from [%s]\n",c_mesg->msg,uin);
	deliver_message(uin, "", jpair_getval(arg,"-for"), NULL, "ICQ message", c_mesg->msg, NULL, NULL, 0, NULL);
	AddContact(c_mesg->uin);
}
static void EventChangeStatus(void* data)
{
	char uin[20];
	USER_UPDATE_PTR user_update;

	user_update = (USER_UPDATE_PTR)data;

	printf("ICQChangeStatus\n");
	sprintf(uin, "%d", user_update->uin);
	printf("Received status from [%d][%s]\n",user_update->uin,user_update->nick);
	status_update(uin, user_update->nick, jpair_getval(arg,"-for"), user_update->status, NULL, NULL, NULL, 0);
}
static void EventSearchResults(void* data)
{
	printf("ICQSearch Results\n");
}
static void EventInfo(void* data)
{
	printf("ICQInfo\n");
}
static void EventExtInfo(void* data)
{
	printf("ICQExt Info\n");
}

void RegisterCallbacks()
{
  ICQ_Register_Callback(EVENT_LOGIN, EventLogin);
  ICQ_Register_Callback(EVENT_DISCONNECT, EventDisconnect);
  ICQ_Register_Callback(EVENT_MESSAGE, EventMessage);
  ICQ_Register_Callback(EVENT_ONLINE, EventChangeStatus);
  ICQ_Register_Callback(EVENT_OFFLINE, EventChangeStatus);
  ICQ_Register_Callback(EVENT_STATUS_UPDATE, EventChangeStatus);
  ICQ_Register_Callback(EVENT_SEARCH_RESULTS, EventSearchResults);
  ICQ_Register_Callback(EVENT_INFO, EventInfo);
  ICQ_Register_Callback(EVENT_EXT_INFO, EventExtInfo);
}

void AddContact(int uin)
{
	int i;
	for(i = 0; i < Num_Contacts; i++)
	{
		if(Contacts[i].uin == uin)
			return;
	}
	Contacts[Num_Contacts].uin = uin;
	strcpy(Contacts[Num_Contacts].nick,"NewUser");
	Contacts[Num_Contacts].status = STATUS_OFFLINE;
	Contacts[Num_Contacts].last_time = -1L;
	Contacts[Num_Contacts].current_ip = -1L;
	Contacts[Num_Contacts].port = -1L;
	Contacts[Num_Contacts].sok = 0;
	Contacts[Num_Contacts].connected = 0;
	Num_Contacts++;
	Send_ContactList();
}

void handle_packet(xpt *x)
{
	xpt *xml, *next;
	char *val = NULL;
	char *type;

	type = x->name;
	if(type == NULL) /* not a valid incoming packet */
	{
		return;
	}

	printf("HERE I am decoding XML!\n");

	/* stringpieces->string->xpt to make sure we get xpt in the end */
	next = x->children;
	while(next != NULL)
	{
		if(next->type == XPT_CDATA)
			val = strgrow(val,next->value,1,0);
		next = next->next;
	}

	xml = xpt_str(val);
	free(val);

	if(NULL == xml)
	{
		printf("Bad XML!\n");
		return;
	}

	if(strcmp(x->name,"r") == 0)
	{
		if(strcmp(xml->name,"message") == 0)
			handle_message(xml);
		if(strcmp(xml->name,"status") == 0)
			handle_status(xml);
		free_xpt(xml);
		return;
	}

	if(strcmp(x->name,"error") == 0)
	{
		printf("Error packet from etherx!\n");
		free_xpt(xml);
		return;
	}

	if(strcmp(x->name,"config") == 0)
	{
		return;
	}
}


void transport_deliver(char *from_user, char *from_nick, char *to_user, char *to_nick, xpt *x)
{
	xpt *to;
	char *str, *packet, *server;
	jpair *attributes = NULL;

	server = strstr(to_user, "@");
	if(server == NULL)
		return;
	else
		++server;

	from_user = strgrow(NULL,from_user,0,0);
	from_user = strgrow(from_user,"@",1,0);
	from_user = strgrow(from_user,jpair_getval(arg,"-name"),1,0);
	x->attributes = jpair_new(x->attributes, "from", from_user, 0);
	x->attributes = jpair_new(x->attributes, "nick", from_nick, 0);

	to = xpt_new_tag(x, "to", NULL);
	if(to_nick != NULL)
		to->attributes = jpair_new(to->attributes, "nick", to_nick, 0);
	xpt_new_cdata(to, to_user);

	attributes = jpair_new(attributes, "to", server, 0);
	attributes = jpair_new(attributes, "from", jpair_getval(arg, "-name"), 0);
	str = xpt2str(x);
	packet = create_packet("r", attributes, str);

	transport->packets = packet_add(transport->packets, packet, from_user);

	free_jpair(attributes);
	free(str);
	free(packet);
}

char *create_packet(char *name, jpair *atts, char *body)
{
	xpt *next;
	char *ret = NULL;
	char *buf = NULL;

	ret = strgrow(ret,"<",1,0);
	ret = strgrow(ret,name,1,0);
	while(atts != NULL)
	{
		ret = strgrow(ret," ",1,0);
		ret = strgrow(ret,atts->key,1,0);
		ret = strgrow(ret,"='",1,0);
		ret = strgrow(ret,strescape(atts->val),1,1);
		ret = strgrow(ret,"'",1,0);
		atts = atts->next;
	}
	ret = strgrow(ret,"><![CDATA[",1,0);
	ret = strgrow(ret,body,1,0);
	ret = strgrow(ret,"]]></",1,0);
	ret = strgrow(ret,name,1,0);
	ret = strgrow(ret,">",1,0);

	return ret;
}


void handle_message(xpt *x)
{
	jpair *to, *jnext;
	char *from_user, *from_nick, *sub, *say, *ext, *thread, *pristr, *type;
	int priority, uin;
	xpt *next, *next2;

	DBG_MSG("handle_message");

	if(x == NULL)
		return;

	to = NULL;
	from_user = jpair_getvalnew(x->attributes, "from");
	from_nick = jpair_getvalnew(x->attributes, "nick");
	if(from_user == NULL)
	{
		DBG_MSG("Invalid message, improper from");
		return;
	}

	pristr = sub = say = ext = thread = NULL;
	priority = 0;

	type = jpair_getvalnew(x->attributes, "type");

	next = x->children;
	while(next != NULL)
	{
		if(next->type == XPT_TAG && strcmp(next->name, "to") == 0)
			to = jpair_add(to,xpt2str_chain(next->children),jpair_getvalnew(next->attributes, "nick"));
		if(next->type == XPT_TAG && strcmp(next->name, "subject") == 0)
			sub = xpt2str_chain(next->children);
		if(next->type == XPT_TAG && strcmp(next->name, "say") == 0)
			say = xpt2str_chain(next->children);
		if(next->type == XPT_TAG && strcmp(next->name, "thread") == 0)
			thread = xpt2str_chain(next->children);
		if(next->type == XPT_TAG && strcmp(next->name, "ext") == 0)
		{
			next2 = next->children;
			ext = NULL;
			while(next2 != NULL)
			{
				ext = strgrow(ext, xpt2str(next2), 1, 1);
				next2 = next2->next;
			}
		}
		if(next->type == XPT_TAG && strcmp(next->name, "priority") == 0)
		{
			pristr = xpt2str_chain(next->children);
			sscanf(pristr,"%d",&priority);
		}
		next = next->next;
	}

	jnext = to;
	while(jnext != NULL)
	{
		/*deliver_message(from_user, from_nick, jnext->key, jnext->val, sub, say, thread, ext, priority, type); */
		sscanf(jnext->key,"%d",&uin);
		printf("Forwarding to [%d] message [%s]\n",uin,say);
		AddContact(uin);
		ICQ_Send_Message(uin, say);
		jnext = jnext->next;
	}

	free(from_user);
	free(from_nick);
	free_jpair(to);
	free(sub);
	free(say);
	free(ext);
	free(thread);
	free(pristr);
	free(type);
}
 

void deliver_message(	char *from_user,
			char *from_nick,
			char *to_user,
			char *to_nick,
			char *subject,
			char *say,
			char *thread,
			char *ext,
			int priority,
			char *type)
{
	xpt *parent, *x;
	char intbuff[20], *server, *str;
	conn *c = NULL;
	jpair *par;

	if(to_user == NULL) /*WTF?*/
		return;

	parent = xpt_new_tag(NULL, "message", NULL);

	if(type != NULL)
		parent->attributes = jpair_new(parent->attributes, "type", type, 0);

	if(subject != NULL)
	{
		x = xpt_new_tag(parent, "subject", NULL);
		xpt_new_cdata(x, subject);
	}

	if(say != NULL)
	{
		x = xpt_new_tag(parent, "say", NULL);
		xpt_new_cdata(x, say);
	}

	if(thread != NULL)
	{
		x = xpt_new_tag(parent, "thread", NULL);
		xpt_new_cdata(x, thread);
	}

	if(ext != NULL)
	{
		x = xpt_new_tag(parent, "ext", NULL);
		xpt_new_cdata(x, ext);
		x->children->name = strdup("NOESCAPE"); /* kludge so that it isn't escaped automatically */
	}

	if(priority != 0)
	{
		x = xpt_new_tag(parent, "priority", NULL);
		sprintf(intbuff,"%d",priority);
		xpt_new_cdata(x, intbuff);
	}


	DBG_VAL("message",xpt2str(parent));

	transport_deliver(from_user, from_nick, to_user, to_nick, parent);

	/* handle the message here !!! */

	free_xpt(parent);
}


void handle_status(xpt *x)
{
	jpair *to, *jnext;
	char *from_user, *from_nick, *say, *ext, *icon, *pristr, *statstr;
	int status, priority, count, uin;
	xpt *next, *next2;

	DBG_MSG("handle_status");

	if(x == NULL)
		return;

	from_user = jpair_getvalnew(x->attributes, "from");
	from_nick = jpair_getvalnew(x->attributes, "nick");
	to = NULL;
	if(from_user == NULL)
	{
		DBG_MSG("Invalid status, improper from");
		return;
	}

	status = STATUS_NORMAL;
	statstr = jpair_getval(x->attributes, "type");
	if(statstr != NULL && strcmp(statstr, "online") == 0)
		status = STATUS_ONLINE;
	if(statstr != NULL && strcmp(statstr, "offline") == 0)
		status = STATUS_OFFLINE;

	pristr = icon = say = ext = NULL;
	priority = 0;

	next = x->children;
	while(next != NULL)
	{
		if(next->type == XPT_TAG && strcmp(next->name, "to") == 0)
			to = jpair_add(to,xpt2str_chain(next->children),jpair_getvalnew(next->attributes, "nick"));
		if(next->type == XPT_TAG && strcmp(next->name, "say") == 0)
			say = xpt2str_chain(next->children);
		if(next->type == XPT_TAG && strcmp(next->name, "icon") == 0)
			icon = xpt2str_chain(next->children);
		if(next->type == XPT_TAG && strcmp(next->name, "ext") == 0)
		{
			next2 = next->children;
			ext = NULL;
			while(next2 != NULL)
			{
				ext = strgrow(ext, xpt2str(next2), 1, 1);
				next2 = next2->next;
			}
		}
		if(next->type == XPT_TAG && strcmp(next->name, "priority") == 0)
		{
			pristr = xpt2str_chain(next->children);
			sscanf(pristr,"%d",&priority);
		}
		next = next->next;
	}

	/* kludge section... we only care when we get statuses from our user */
	if(strcmp(from_user,jpair_getval(arg,"-for")) == 0)
	{
		sscanf(to->key,"%d",&uin);
		switch(status)
		{
			case STATUS_ONLINE: /* store this new session */
				AddContact(uin); /* so that we get status to forward to our user */
				jnext = sessions;
				count = 0;
				while(jnext != NULL)
				{
					if(strcmp(jnext->key,from_user) == 0 && strcmp(jnext->val,from_nick) == 0)
						break; /* already online session! */
					if(strcmp(jnext->key,from_user))
						count++; /* number of valid sessions, ghads I'm lazy, BAD */
					jnext = jnext->next;
				}
				if(count == 0)
					ICQ_Change_Status(STATUS_ONLINE);
				sessions = jpair_new(sessions,from_user,from_nick,0);
				break;
			case STATUS_OFFLINE:
				jnext = sessions;
				count = 0;
				while(jnext != NULL)
				{
					if(strcmp(jnext->key,from_user) == 0 && strcmp(jnext->val,from_nick) == 0)
						*(jnext->key) = '\0'; /* LAZY, so we don't match this session again */
					if(strcmp(jnext->key,from_user))
						count++; /* number of valid sessions left, ghads I'm lazy, BAD */
					jnext = jnext->next;
				}
				if(count == 0)
					ICQ_Change_Status(STATUS_OFFLINE);
				break;
		}
	}

	free(from_user);
	free(from_nick);
	free_jpair(to);
	free(icon);
	free(say);
	free(ext);
	free(pristr);
}


void status_update(char *user, char *nick, char *to, int status, char *say, char *icon, char *ext, int priority)
{ 
	xpt *parent, *x;
	char intbuff[20], *server;

	parent = xpt_new_tag(NULL, "status", NULL);

	switch(status)
	{
		case STATUS_NORMAL:
			break;
		case STATUS_ONLINE:
			parent->attributes = jpair_new(NULL, "type", "online", 0);
			break;
		case STATUS_OFFLINE:
			parent->attributes = jpair_new(NULL, "type", "offline", 0);
			break;
	}

	if(say != NULL)
	{
		x = xpt_new_tag(parent, "say", NULL);
		xpt_new_cdata(x, say);
	}

	if(icon != NULL)
	{
		x = xpt_new_tag(parent, "icon", NULL);
		xpt_new_cdata(x, icon);
	}

	if(ext != NULL)
	{
		x = xpt_new_tag(parent, "ext", NULL);
		xpt_new_cdata(x, ext);
		x->children->name = strdup("NOESCAPE"); /* kludge so that it isn't escaped automatically */
	}

	if(priority != 0)
	{
		x = xpt_new_tag(parent, "priority", NULL);
		sprintf(intbuff,"%d",priority);
		xpt_new_cdata(x, intbuff);
	}


	DBG_VAL("status",xpt2str(parent));

	/* handle status here */

	free_xpt(parent);
}


