#include "template.h"

void sig_die()
{
	ERROR("main","Exiting Template Transport");
	longjmp(_jabberlib_ioenv,1);
}

char *make_tag_quick(char *name, char *value)
{
	char *ret;

	if(value == NULL)
		return NULL;

	if(*value == '\0')
		return NULL;

	value = strescape(value);
	ret = malloc(strlen(name)*2 + strlen(value) + 6); 
	sprintf(ret,"<%s>%s</%s>",name,value,name);
	free(value);

	return ret;
}

void logger(int level, char *from, char *message)
{
	static time_t t;
	static int log, checklog;
	char *tstr, *tmpctime;
	int check;

	/* initialize and open the logfile if configured to do so */
	if(checklog != 1)
	{
		log = -1;
		if(jpair_get(etc.vars, "errorlog") != NULL)
		{
			checklog = 1;
			log = open(jpair_getval(etc.vars, "errorlog"), O_WRONLY | O_CREAT | O_APPEND);
			if(log < 0)
				ERROR("main", "Unable to open errorlog");
		}
	}

	/* log only at the level told to do so */
	if(level >= etc.debug)
	{
		time(&t);
		tstr = strgrow(NULL,"[",0,0);
		tmpctime = strdup(ctime(&t));
		tmpctime[strlen(tmpctime) - 1] = '\0';
		tstr = strgrow(tstr,tmpctime,1,1);
		tstr = strgrow(tstr,"] ",1,0);
		tstr = strgrow(tstr,from,1,0);
		tstr = strgrow(tstr," \"",1,0);
		if(message != NULL)
			tstr = strgrow(tstr,message,1,0);
		tstr = strgrow(tstr,"\"\n",1,0);

		/* if a logfile is configured and opened, put logs there unless were debugging */
		if(log >= 0 && etc.debug > SYSLOG_DEBUG)
		{
			check = write(log, tstr, strlen(tstr));
			if(check != strlen(tstr))
			{
				log = -1;
				ERROR("main", "Writing to error log file failed!");
				syslog(level, from, message);
			}
		}else{
			printf("%s",tstr);
		}

		free(tstr);
	}
}

